<?php

class Addoldcolumns extends Controller {

    function Addoldcolumns() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('configmodel');
    }

    function selectcolumns($type = 'column') {
        $formName = $this->session->userdata('formName');
        $tableName = $this->session->userdata('tableName');
        $this->load->model('formmodel');
        $tableColumnList = $this->formmodel->getTableColumns($tableName);
        if ($type == 'filter') {
            foreach ($tableColumnList as $key => $columnName) {
                $this->table->add_row(anchor('addoldcolumns/add/filter/'.$columnName, $columnName, array('class' =>
                                     'add')));
                $data['contentTitle'] = "Select a Data Filter - ".$formName;
            }
        }
        else {
            foreach ($tableColumnList as $key => $columnName) {
                $this->table->add_row(anchor('addoldcolumns/add/column/'.$columnName, $columnName, array('class' =>
                                     'add')));
                $data['contentTitle'] = "Select a Column - ".$formName;
            }
        }
        $data['table'] = $this->table->generate();
        $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        $data['title'] = "Configuration Form";
        $data['formHeading'] = "";
        $this->load->view('forms/selectcolumntype', $data);
    }

    function add($type, $columnName) {
        $data['title'] = "Configuration Form";
        if ($type == 'filter') {
            $data['contentTitle'] = "Add Data Filter";
            $data['formOpen'] = form_open("addoldcolumns/addvalidate/filter/".$columnName);
            $data['backLink'] = anchor('addoldcolumns/selectcolumns/filter', 'Back', array('class' => 'back'));
        }
        else {
            $data['contentTitle'] = "Add Old Column";
            $data['formOpen'] = form_open("addoldcolumns/addvalidate/column/".$columnName);
            $data['backLink'] = anchor('addoldcolumns/selectcolumns/', 'Back', array('class' => 'back'));
        }
        $data['formHeading'] = "";
        $data['table'] = $this->_addColumnTable($columnName);
        $this->load->view('forms/simpleform', $data);
    }

    function addvalidate($type, $columnName) {
        $this->_validateAddForm();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            if ($type == 'filter') {
                $data['contentTitle'] = "Add Data Filter";
                $data['formOpen'] = form_open("addoldcolumns/addvalidate/filter/".$columnName);
                $data['backLink'] = anchor('addoldcolumns/selectcolumns/filter', 'Back', array('class' => 'back'));
            }
            else {
                $data['contentTitle'] = "Add Old Column";
                $data['formOpen'] = form_open("addoldcolumns/addvalidate/column/".$columnName);
                $data['backLink'] = anchor('addoldcolumns/selectcolumns/', 'Back', array('class' => 'back'));
            }
            $data['formHeading'] = "";
            $data['table'] = $this->_addColumnTable($columnName);
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $tableName = $this->session->userdata('tableName');
            if ($type == 'filter') {
                $columnType = 'Filter';
                $columnNumber = $this->configmodel->getColumnNumberFilter($formName, $formType);
            }
            else {
                $columnType = "Old";
                $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            }
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $columnSize = $this->input->post('columnSize');
            $attributes = join("\t", array($columnHeader, $columnName, $columnSize));
            $this->configmodel->insertFormDataOld($formType, $tableName, $formName, $columnNumber, $columnType, $attributes
                                                 );
            redirect('forms/addcolumnold');
        }
    }

    function _addColumnTable($columnName) {
        $columnHeader = set_value('columnHeader');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName,
                            'readonly' => 'readonly', 'style' => 'background:#CCCCCC;');
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $columnSizeTbx = form_input($columnSizeA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx.$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx.$columnNameErr), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateAddForm() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    //////////////////Simple textbox with text,integer or decimal values with no limits///////////////////
    function textform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Simple Text Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/textformvalidate");
        $data['table'] = $this->_textFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function textformvalidate() {
        $this->_validatetextform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Simple Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/textformvalidate");
            $data['table'] = $this->_textFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $tableName = $this->session->userdata('tableName');
            $columnType = "text";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $defaultValue, $columnSize, $allowNull
                              ));
            $this->configmodel->insertFormDataOld($formType, $tableName, $formName, $columnNumber, $columnType, $attributes
                                                 );
            redirect('forms/addcolumnold');
        }
    }

    function _textFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $dataTypeA = array('default' => 'Select', 'varchar' => 'varchar', 'integer' => 'integer', 'float' => 'float',
                          'decimal' => 'decimal');
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        //$columnNameDD = form_dropdown('columnName',$columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $defaultValueTbx = form_input($defaultValueA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Default Value : ', $defaultValueTbx), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Null Value Allowed: ', $allowNullDD), array(), array('', $submitButton."\t".$resetButton
                           ));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatetextform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required|alpha_numeric');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ///////////////////////////////////////////////////////
    //////Simple text box with interger values and a limit check//////////
    function limitform() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Limit Form";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/limitformvalidate");
        $data['table'] = $this->_limitFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function limitformvalidate() {
        $this->_validatelimitform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Simple Text Form";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/limitformvalidate");
            $data['table'] = $this->_limitFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $tableName = $this->session->userdata('tableName');
            $columnType = "limit";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $dataType = $this->input->post('dataType');
            $upperLimit = $this->input->post('upperLimit');
            $lowerLimit = $this->input->post('lowerLimit');
            $defaultValue = $this->input->post('defaultValue');
            $columnSize = $this->input->post('columnSize');
            $allowNull = $this->input->post('allowNull');
            $attributes = join("\t", array($columnHeader, $columnName, $dataType, $upperLimit, $lowerLimit, $defaultValue,
                              $columnSize, $allowNull));
            $this->configmodel->insertFormDataOld($formType, $tableName, $formName, $columnNumber, $columnType, $attributes
                                                 );
            redirect('forms/addcolumnold');
        }
    }

    function _limitFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $dataType = set_value('dataType');
        $upperLimit = set_value('upperLimit');
        $lowerLimit = set_value('lowerLimit');
        $defaultValue = set_value('defaultValue');
        $columnSize = set_value('columnSize');
        if ($columnSize == "") {
            $columnSize = 10;
        }
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $dataTypeA = array('default' => 'Select', 'integer' => 'integer', 'float' => 'float', 'decimal' => 'decimal');
        $upperLimitA = array('name' => 'upperLimit', 'id' => 'upperLimit', 'size' => '16', 'value' => $upperLimit);
        $lowerLimitA = array('name' => 'lowerLimit', 'id' => 'lowerLimit', 'size' => '16', 'value' => $lowerLimit);
        $defaultValueA = array('name' => 'defaultValue', 'id' => 'defaultValue', 'size' => '16', 'value' => $defaultValue
                              );
        $columnSizeA = array('name' => 'columnSize', 'id' => 'columnSize', 'size' => '16', 'value' => $columnSize);
        $allowNullA = array('no' => 'No', 'yes' => 'Yes');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $dataTypeDD = form_dropdown('dataType', $dataTypeA);
        $defaultValueTbx = form_input($defaultValueA);
        $upperLimitTbx = form_input($upperLimitA);
        $lowerLimitTbx = form_input($lowerLimitA);
        $columnSizeTbx = form_input($columnSizeA);
        $allowNullDD = form_dropdown('allowNull', $allowNullA, 'yes');
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $dataTypeErr = form_error('dataType');
        $columnSizeErr = form_error('columnSize');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx, $columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx, $columnNameErr), array('Data Type : ', $dataTypeDD, $dataTypeErr
                           ), array('Upper Limit : ', $upperLimitTbx), array('Lower Limit : ', $lowerLimitTbx), array(
                           'Default Value : ', $defaultValueTbx), array('Column Size : ', $columnSizeTbx, $columnSizeErr
                           ), array('Null Value Allowed: ', $allowNullDD), array(), array('', $submitButton."\t".$resetButton
                           ));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatelimitform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required|alpha_numeric');
        $this->form_validation->set_rules('dataType', 'Data Type', 'callback_dropdown_check');
        $this->form_validation->set_rules('columnSize', 'Column Size', 'trim|required|integer');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    ////////////*******************///////////////////////
    ////////////User Dropdown/////////////////////////
    function userdropdown() {
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "User Dropdown";
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("addoldcolumns/userdropdownvalidate");
        $data['table'] = $this->_userFormTable();
        $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function userdropdownvalidate() {
        $this->_validateuserqueryform();
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "User Dropdown";
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("addoldcolumns/userdropdownvalidate");
            $data['table'] = $this->_userFormTable();
            $data['backLink'] = anchor('forms/selectcolumntype/', 'Back', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            //insert into database
            $formName = $this->session->userdata('formName');
            $formType = $this->session->userdata('formType');
            $tableName = $this->session->userdata('tableName');
            $columnType = "userdd";
            $columnNumber = $this->configmodel->getColumnNumber($formName, $formType);
            $columnHeader = $this->input->post('columnHeader');
            $columnName = $this->input->post('columnName');
            $userData = $this->input->post('userData');
            $attributes = join("\t", array($columnHeader, $columnName, $userData));
            $this->configmodel->insertFormDataOld($formType, $tableName, $formName, $columnNumber, $columnType, $attributes
                                                 );
            redirect('forms/addcolumnold');
        }
    }

    function _userFormTable() {
        $columnHeader = set_value('columnHeader');
        $columnName = set_value('columnName');
        $userData = set_value('userData');
        $stemChange = set_value('stemChange');
        $treeChange = set_value('treeChange');
        $columnHeaderA = array('name' => 'columnHeader', 'id' => 'columnHeader', 'size' => '16', 'value' => $columnHeader
                              );
        $columnNameA = array('name' => 'columnName', 'id' => 'columnName', 'size' => '16', 'value' => $columnName);
        $userDataA = array('name' => 'userData', 'id' => 'userData', 'value' => $userData, 'class' => 'textarea1');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $resetButtonA = array('name' => 'resetButton', 'id' => 'button', 'type' => 'reset', 'content' => 'Reset');
        $columnHeaderTbx = form_input($columnHeaderA);
        $columnNameTbx = form_input($columnNameA);
        $userDataTarea = form_textarea($userDataA);
        $submitButton = form_button($submitButtonA);
        $resetButton = form_button($resetButtonA);
        $columnHeaderErr = form_error('columnHeader');
        $columnNameErr = form_error('columnName');
        $userDataErr = form_error('userData');
        $formTableA = array(array(), array('Column Header : ', $columnHeaderTbx.$columnHeaderErr), array(
                           'Column Name : ', $columnNameTbx.$columnNameErr), array('User Data : ', $userDataTarea),
                           array('', "Enter Dropdown options, separated by ; (Example: a;b;c)"), array('', $userDataErr),
                           array(), array('', $submitButton."\t".$resetButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateuserqueryform() {
        $this->form_validation->set_rules('columnHeader', 'Column Header', 'trim|required');
        $this->form_validation->set_rules('columnName', 'Column Name', 'trim|required');
        $this->form_validation->set_rules('userData', 'User Data', 'required');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    //////////////////////////////////////////////////////////////////////////
    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

}
