<?php

class Dataentry extends Controller {

    function Dataentry() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        global $databaseName;
        $databaseName = $this->session->userdata('selectedPlotName');
        set_time_limit(0);
        ini_set('memory_limit', '-1');
    }

    function formtype() {
        if (isset ($this->session->userdata['formType'])) {
            $this->session->unset_userdata('formType');
        }
        if (isset ($this->session->userdata['formName'])) {
            $this->session->unset_userdata('formName');
        }
        $formTableA = array(array(''), array(anchor('/dataentry/formname', 'New Form Data Entry',array('title' =>
                           'New Form Data Entry', 'class' => 'forward'))), array(anchor(
                           '/dataentry/formname/Old', 'Old Form Data Entry', array('title' => 'Old Form Data Entry',
                           'class' => 'forward'))),);
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select Form Type";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['table'] = $this->table->generate($formTableA);
        $data['backLink'] = "";
        $this->load->view('forms/simpleform', $data);
    }

    function formname($formType = 'New') {
        if (isset ($this->session->userdata['formName'])) {
            $this->session->unset_userdata('formName');
        }
        $this->session->set_userdata('formType', $formType);
        $data['title'] = "Data Entry";
        if ($formType == 'Old') {
            $data['contentTitle'] = "Select Form Name - Old Form";
        }
        else {
            $data['contentTitle'] = "Select Form Name - New Form";
        }
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("dataentry/formnamevalidate");
        $data['table'] = $this->_selectFormNameTable($formType);
        $data['backLink'] = anchor('dataentry/formtype/', 'Back - Form Type', array('class' => 'back'));
        $this->load->view('forms/simpleform', $data);
    }

    function formnamevalidate() {
        global $databaseName;
        $formType = $this->session->userdata('formType');
        $this->_validateFormName('dropDown');
        $fileName = $this->input->post('formNameDD');
        $fileNameSplit = explode('_', $fileName);
        $formName = $fileNameSplit[0];
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Data Entry";
            if ($formType == 'Old') {
                $data['contentTitle'] = "Select Form Name - Old Form";
                $tableName = $fileNameSplit[2];
            }
            else {
                $data['contentTitle'] = "Select Form Name - New Form";
                $tableName = "";
            }
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("dataentry/formnamevalidate");
            $data['table'] = $this->_selectFormNameTable($formType);
            $data['backLink'] = anchor('dataentry/formtype/', 'Back - Form Type', array('class' => 'back'));
            $this->load->view('forms/simpleform', $data);
        }
        else {
            if ($formType == 'Old') {
                $tableName = $fileNameSplit[2];
            }
            else {
                $tableName = "";
            }
            $this->session->set_userdata('formName', $formName);
            $this->session->set_userdata('tableName', $tableName);
            redirect('dataentry/mainmenu');
        }
    }

    function _selectFormNameTable($formType) {
        global $databaseName;
        if($formType == 'Old') {
          $splitCount = 3;
        }
        else {
          $splitCount = 2;
        }
        $dir = "./files/configfiles/";
        if (is_dir($dir)) {
            if ($dh = opendir($dir)) {
                $formNameArray = array();
                //$fileNameArray['default'] = 'No Files In Folder';
                while (($file = readdir($dh)) !== false) {
                    if ($file !== "." && $file !== "..") {
                        $fileSplit = explode(".", $file);
                        $fileName = $fileSplit[0];
                        // Remove .txt from the end - need to remove for dropdown
                        $fileSplit1 = explode("_", $fileName);
                        if(count($fileSplit1) == $splitCount) {
                          if ($fileSplit1[1] == $databaseName) {
                              $formNameArray[$fileName] = $fileSplit1[0];
                          }
                        }
                        //$fileNameArray['default'] = 'Select';
                    }
                }
                natcasesort($formNameArray);
                $defaultArray = array('default' => 'Select');
                $formNameArray = array_merge($defaultArray, $formNameArray);
                closedir($dh);
            }
        }
        else {
            $formNameArray = array('default' => 'No Directory');
        }
        $formName = set_value('formNameTbx');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $formNameDD = form_dropdown('formNameDD', $formNameArray);
        $submitButton = form_button($submitButtonA);
        $formNameDDErr = form_error('formNameDD');
        $formTableA = array(array(), array('Select Form : ', $formNameDD, $formNameDDErr), array('',
                           '<p style="text-align:center;">'.$submitButton.'</p>'));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateFormName($columnType) {
        if ($columnType == 'dropDown') {
            $this->form_validation->set_rules('formNameDD', 'Form Name', 'callback_dropdown_check');
        }
        else {
            $this->form_validation->set_rules('formNameTbx', 'Form Name', 'required|max_length[40]');
        }
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

    function mainmenu() {
        if (!isset ($this->session->userdata['formType'])) {
            $this->formType();
        }
        if (!isset ($this->session->userdata['formName'])) {
            $this->formname();
        }

        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        if($formType == 'Old') {
          $formTableA = array(array(''), array(anchor('/oldentryform', 'Entry Form', array('title' => 'Entry Form',
                           'class' => 'forward'))));
        }
        else {
          $formTableA = array(array(''), array(anchor('/gdeplantform', 'Entry Form', array('title' => 'Entry Form',
                           'class' => 'forward'))), array(anchor('/selectmergefile/selectfile',
                           'Add More Data Into Existing File', array('title' => 'Add More Data Into Existing File',
                           'class' => 'forward'))),);
        }

        $this->table->set_empty("");
        $data['formTable'] = $this->table->generate($formTableA);
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName
        .'</span></span>';
        $this->load->view('user/dataentry/mainmenu', $data);
    }

    function uploaddata() {
        if (!isset ($this->session->userdata['formName'])) {
            $this->formname();
        }
        $formName = $this->session->userdata('formName');
        $formTableA = array(array(''), array(anchor('/gdedataupload/uploadall', 'Upload all the Files for this form',
                           array('title' => 'Upload All Files', 'class' => 'forward', 'onclick' =>
                           "return confirm('Are you sure you want to upload all data for this form?')"))), array(anchor(
                           '/gdedataupload/uploadselect', 'Select a file to Upload', array('title' =>
                           'Upload Selected File', 'class' => 'forward'))));
        $this->table->set_empty("");
        $data['formTable'] = $this->table->generate($formTableA);
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Data Uploading - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span></span>';
        $this->load->view('user/dataentry/mainmenu', $data);
    }

    function datascreening() {
        if (!isset ($this->session->userdata['formName'])) {
            $this->formname();
        }
        $formName = $this->session->userdata('formName');
        $formTableA = array(array(''), array(anchor('/doublescreening/tableselect', 'Compare Data in Temporary Tables - Double Data Entry',
                           array('title' => 'Compare Data in Temporary Tables - Double Data Entry', 'class' => 'forward'))), array(anchor(
                           '/dataview/tableselect', 'View all the Screened Records in Temporary Tables', array('title'
                           => 'View all the Records in Temporary Tables', 'class' => 'forward'))),);
        $this->table->set_empty("");
        $data['formTable'] = $this->table->generate($formTableA);
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Select Data Screening Type - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName
        .'</span>';
        $this->load->view('user/dataentry/mainmenu', $data);
    }

    function doubledataentry() {
        if (!isset ($this->session->userdata['formName'])) {
            $this->formname();
        }
        $formName = $this->session->userdata('formName');
        $formTableA = array(array(''), array(anchor('/doublescreening/tableselect', 'Compare Data in Temporary Tables',
                           array('title' => 'Compare Data in Temporary Tables', 'class' => 'forward'))), array(anchor(
                           '/dataview/selectformtype', 'View all the Screened Records in Temporary Tables', array(
                           'title' => 'View all the Records in Temporary Tables', 'class' => 'forward'))));
        $this->table->set_empty("");
        $data['formTable'] = $this->table->generate($formTableA);
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Double Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span>';
        $this->load->view('user/dataentry/mainmenu', $data);
    }

    function fileExists($path) {
        return (@ fopen($path, "r") == true);
    }

}
