<?php

class Doublescreening extends Controller {

    function Doublescreening() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('doublescreeningmodel');
        set_time_limit(0);
        ini_set('memory_limit', '-1');
    }

    function tableselect() {
        if (isset ($this->session->userdata['tableNames'])) {
            $this->session->unset_userdata('tableNames');
        }
        if (isset ($this->session->userdata['columnNames'])) {
            $this->session->unset_userdata('columnNames');
        }
        $formName = $this->session->userdata('formName');
        $like = substr($formName, 0, - 1)."%";
        $tableNameArray = $this->doublescreeningmodel->tableNameList($like);
        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectFileTable($tableNameArray, $formName);
        $data['formOpen'] = form_open("doublescreening/tableselectvalidate");
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Double Data Screening - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span></span>';
        $data['backLink'] = anchor('/dataentry/datascreening', 'Back', array('title' => 'Back to Select Form Type',
                                  'class' => 'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function tableselectvalidate() {
        $formType = $this->session->userdata('formType');
        $this->_validatetwofileupload();
        if ($this->form_validation->run() == FALSE) {
            $formName = $this->session->userdata('formName');
            $like = substr($formName, 0, - 1)."%";
            $tableNameArray = $this->doublescreeningmodel->tableNameList($like);
            //form with drop down - listing temp tables in the selected form type
            $data['formTable'] = $this->_selectFileTable($tableNameArray, $formName);
            $data['formOpen'] = form_open("doublescreening/tableselectvalidate");
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'Double Data Screening - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['backLink'] = anchor('/dataentry/datascreening', 'Back', array('title' => 'Back to Select Form Type',
                                      'class' => 'back'));
            $this->load->view('user/dataentry/simpleform', $data);
        }
        else {
            $tableName1 = $this->input->post('tableName1');
            $tableName2 = $this->input->post('tableName2');
            $tableNameFinal = substr($tableName1, 0, - 1);
            $tableNameFinal = $tableNameFinal."Final";
            //create final table
            if ($formType == 'Old') {
                $createTable = $this->_createOldTable($tableNameFinal);
            }
            else {
                $createTable = $this->_createTable($tableNameFinal);
            }
            $createTableQuery = $createTable['createQuery'];
            $columnNameA = $createTable['columnNameA'];
            $headerListA = $createTable['headerListA'];
            $this->doublescreeningmodel->executeQuery($createTableQuery);
            $tableNames['tableName1'] = $tableName1;
            $tableNames['tableName2'] = $tableName2;
            $tableNames['tableNameFinal'] = $tableNameFinal;
            $tableColumnNames['columnNameA'] = $columnNameA;
            $tableColumnNames['headerListA'] = $headerListA;
            $this->session->set_userdata('tableNames', $tableNames);
            $this->session->set_userdata('columnNames', $tableColumnNames);
            redirect('doublescreening/selectcomparecolumns');
        }
    }

    function _selectFileTable($tableNameArray, $formName) {
        $tableName1 = set_value('tableName1');
        $tableName2 = set_value('tableName2');
        $tableName1DD = form_dropdown('tableName1', $tableNameArray, $tableName1);
        $tableName2DD = form_dropdown('tableName2', $tableNameArray, $tableName2);
        $tableNameHd = form_hidden('tableNameArray', $tableNameArray);
        ;
        $tableName1Err = form_error('tableName1');
        $tableName2Err = form_error('tableName2');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array(), array('Table 1 : ', $tableName1DD, $tableName1Err), array('Table 2 : ', $tableName2DD,
                           $tableName2Err), array('', $tableNameHd), array('', $submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validatetwofileupload() {
        $this->form_validation->set_rules('tableName1', 'Table 1', 'callback_dropdown_check');
        $this->form_validation->set_rules('tableName2', 'Table 2', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function selectcomparecolumns() {
        if (isset ($this->session->userdata['selectedCompare'])) {
            $this->session->unset_userdata('selectedCompare');
        }
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/tableselect');
        }
        $formName = $this->session->userdata('formName');
        $tableNames = $this->session->userdata('tableNames');
        $tableName1 = $tableNames['tableName1'];
        $errorMessage = "";
        //form with drop down - listing temp tables in the selected form type
        $data['formTable'] = $this->_selectCompareTable($tableName1, $errorMessage);
        $data['formOpen'] = form_open("doublescreening/selectcomparevalidate");
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Select Primary Columns - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span></span>';
        $data['backLink'] = anchor('/doublescreening/tableselect', 'Back', array('title' => 'Back to Select Tables',
                                  'class' => 'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function selectcomparevalidate() {
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/tableselect');
        }
        $selectedCheckArray = $this->input->post('checkbox');
        if ($selectedCheckArray == '') {
            $formName = $this->session->userdata('formName');
            $tableNames = $this->session->userdata('tableNames');
            $tableName1 = $tableNames['tableName1'];
            $errorMessage = '<p class="errorblock">Atleast One Column Need To Be Selected.</p>';
            //form with drop down - listing temp tables in the selected form type
            $data['formTable'] = $this->_selectCompareTable($tableName1, $errorMessage);
            $data['formOpen'] = form_open("doublescreening/selectcomparevalidate");
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'Select Primary Columns - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName
            .'</span></span>';
            $data['backLink'] = anchor('/doublescreening/tableselect', 'Back', array('title' => 'Back to Select Tables',
                                      'class' => 'back'));
            $this->load->view('user/dataentry/simpleform', $data);
        }
        else {
            $this->session->set_userdata('selectedCompare', $selectedCheckArray);
            redirect('doublescreening/screentwotables');
        }
    }

    function _selectCompareTable($tableName1, $errorMessage) {
        $tableQuery1 = $this->doublescreeningmodel->getColumnNames($tableName1);
        foreach ($tableQuery1 as $field) {
            if ($field != $tableName1.'ID') {
                $checkData = array('name' => 'checkbox[]', 'id' => 'checkbox', 'value' => $field);
                $columnNameCheckArray[] = form_checkbox($checkData).$field."<br/>";
            }
        }
        $joinValues = "";
        foreach ($columnNameCheckArray as $key => $value) {
            $joinValues = $joinValues.$value;
        }
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array('Select one or more primary columns to compare two tables', $errorMessage), array($joinValues
                           ), array(), array($submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function screentwotables() {
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/tableselect');
        }
        elseif (!isset ($this->session->userdata['selectedCompare'])) {
            redirect('doublescreening/selectcomparecolumns');
        }
        $tableNames = $this->session->userdata('tableNames');
        $tableName1 = $tableNames['tableName1'];
        $tableName2 = $tableNames['tableName2'];
        $tableNameFinal = $tableNames['tableNameFinal'];
        $selectedCheckArray = $this->session->userdata('selectedCompare');
        $tableQuery1 = $this->doublescreeningmodel->fetchAllRecords($tableName1);
        if ($tableQuery1->num_rows > 0) {
            $numRecords = $tableQuery1->num_rows;
            foreach ($tableQuery1->result_array() as $tableRow1) {
                $whereArray = array();
                foreach ($selectedCheckArray as $field) {
                    $whereArray[$field] = $tableRow1[$field];
                }
                $tableQuery2 = $this->doublescreeningmodel->fetchCompareRecord($tableName2, $whereArray);
                if ($tableQuery2->num_rows > 0) {
                    $status = $this->_compareRecords($tableRow1, $tableQuery2, $tableName1, $tableName2, $tableNameFinal
                                                    );
                    if ($status == 'diff') {
                        $this->_displayRecords($tableRow1, $tableQuery2, $tableName1, $tableName2, $tableNameFinal);
                        break;
                    }
                }
                else {
                    //Records Missing in Table 2
                    $tableQuery2Missing = "missing";
                    $this->_displayRecords($tableRow1, $tableQuery2Missing, $tableName1, $tableName2, $tableNameFinal);
                    break;
                }
                $numRecords = $numRecords - 1;
            }
            if ($numRecords == 0) {
                redirect('doublescreening/screentwotables');
            }
        }
        else {
            $tableQuery2 = $this->doublescreeningmodel->fetchAllRecords($tableName2);
            if ($tableQuery2->num_rows > 0) {
                $data['title'] = "Data Entry";
                $data['contentTitle'] = "Data Screening - Choose Correct Record";
                $data['formOpen'] = "";
                $data['backLink'] = anchor('doublescreening/tableselect', 'Back', array('class' => 'back'));
                $data['button1'] = "";
                $data['button2'] = "";
                $data['table'] = "<div class='success'>All Records in ".$tableName1." are screened. <br />But ".$tableName2
                ." still have some data.<br /><br />Do you want to screen this table too.".anchor(
                                                                                                 'doublescreening/screensecondtable/',
                                                                                                 'Yes', array('class' =>
                                                                                                 'forward'))."</div>";
                $this->load->view('user/dataentry/screentwotable', $data);
            }
            else {
                $data['title'] = "Data Entry";
                $data['contentTitle'] = "Data Screening";
                $data['formOpen'] = "";
                $data['backLink'] = anchor('doublescreening/tableselect', 'Back', array('class' => 'back'));
                $data['button1'] = "";
                $data['button2'] = "";
                $data['table'] =
                "<div class='success'>All Records are screened. Table doesn't contain any more records.";
                $this->load->view('user/dataentry/screentwotable', $data);
            }
        }
    }

    function screensecondtable() {
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/tableselect');
        }
        $tableNames = $this->session->userdata('tableNames');
        $tableName1 = $tableNames['tableName1'];
        $tableName2 = $tableNames['tableName2'];
        $tableNameFinal = $tableNames['tableNameFinal'];
        //Now switch table 1 and table 2
        $tableNames['tableName1'] = $tableName2;
        $tableNames['tableName2'] = $tableName1;
        $tableNames['tableNameFinal'] = $tableNameFinal;
        $this->session->set_userdata('tableNames', $tableNames);
        redirect('doublescreening/screentwotables');
    }

    function _compareRecords($tableRow1, $tableQuery2, $tableName1, $tableName2, $tableNameFinal) {
        foreach ($tableQuery2->result_array() as $tableRow2) {
            $tableRow1Compare = $tableRow1;
            $tableRow2Compare = $tableRow2;
            unset ($tableRow1Compare[$tableName1.'ID']);
            unset ($tableRow2Compare[$tableName2.'ID']);
            //$columnDiff = array_diff($tableRow1Compare,$tableRow2Compare);
            $columnDiff = $this->arraysDiff($tableRow1Compare, $tableRow2Compare);
            if ($columnDiff == 0) {
                $status = 'same';
                //copy the record from table 1 to temp table final
                foreach ($tableRow1 as $key => $value) {
                    if ($key !== $tableName1.'ID') {
                        $insertRowArray[$key] = $tableRow1[$key];
                    }
                }
                $this->doublescreeningmodel->insertRowIntoTable($tableNameFinal, $insertRowArray);
                //delete from table 1 and table 2
                $tempID1 = $tableRow1[$tableName1.'ID'];
                $this->doublescreeningmodel->deleteTempRecord($tableName1, $tempID1);
                $tempID2 = $tableRow2[$tableName2.'ID'];
                $this->doublescreeningmodel->deleteTempRecord($tableName2, $tempID2);
                //break
                break;
            }
            else {
                $status = 'diff';
            }
        }
        return $status;
    }

    function _displayRecords($tableRow1, $tableQuery2, $tableName1, $tableName2, $tableNameFinal) {
        $columnNames = $this->session->userdata('columnNames');
        $headerListA = $columnNames['headerListA'];
        $columnNameA = $columnNames['columnNameA'];
        ////////////Table 1 Display Column///////////////
        $tempID1 = $tableRow1[$tableName1.'ID'];
        $radioData1 = array('name' => 'radioTable', 'id' => 'radioTable', 'value' => "table1_".$tempID1, 'checked' =>
                           'TRUE');
        $radioTable1 = form_radio($radioData1);
        $textboxNamesA = array();
        //to get a list of names given to textboxes
        $allRecordsA = array();
        //to get a list of records listed to delete it from table1 and table2
        $allRecordsA[] = "table1_".$tempID1;
        foreach ($columnNameA as $key => $value) {
            $textboxType = 'same';
            $columnName = $value."_table1_".$tempID1;
            $textboxNamesA[] = $value;
            $columnValue = $tableRow1[$value];
            $textbox = $this->_createTextbox($columnName, $columnValue, $textboxType);
            $tableArray1[$value] = $textbox;
        }
        $headerListShift = $headerListA;
        array_unshift($headerListShift, " ");
        array_unshift($tableArray1, $radioTable1);
        $tmpl = array('table_open' => '<table id="formtable">');
        $this->table->set_template($tmpl);
        $this->table->set_empty("&nbsp;");
        $this->table->set_heading($headerListShift);
        $this->table->add_row('<h3>Table1</h3>');
        $this->table->add_row($tableArray1);
        /////////////////////////////////////////////////////
        /////////////////Table 2 Display Column//////////////
        $this->table->add_row('<h3>Table2</h3>');
        if ($tableQuery2 === 'missing') {
            $this->table->add_row("", "<h5>Record Missing</h5>");
        }
        else {
            foreach ($tableQuery2->result_array() as $tableRow2) {
                $tempID2 = $tableRow2[$tableName2.'ID'];
                $allRecordsA[] = "table2_".$tempID2;
                foreach ($columnNameA as $key => $value) {
                    $textboxType = 'same';
                    $columnName = $value."_table2_".$tempID2;
                    $columnValueTable1 = $tableRow1[$value];
                    $columnValue = $tableRow2[$value];
                    if ($columnValueTable1 !== $columnValue) {
                        $textboxType = 'diff';
                    }
                    $textbox = $this->_createTextbox($columnName, $columnValue, $textboxType);
                    $tableArray2[$value] = $textbox;
                }
                $radioData2 = array('name' => 'radioTable', 'id' => 'radioTable', 'value' => "table2_".$tempID2);
                $radioTable2 = form_radio($radioData2);
                $shiftTableArray2 = $tableArray2;
                array_unshift($shiftTableArray2, $radioTable2);
                $this->table->add_row($shiftTableArray2);
            }
        }
        $table = $this->table->generate();
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit >');
        $submitButton = form_button($submitButtonA);
        $textboxNamesHD = form_hidden('textboxNamesA', $textboxNamesA);
        $allRecordsHD = form_hidden('allRecordsA', $allRecordsA);
        $skipButton = anchor('doublescreening/skiprecord/'.$tempID1, 'Skip Record', array('title' =>
                            'Skip This Record For Now', 'class' => 'next'));
        $deleteButton = '<p align="right" style="margin:-25px 0 10px 0;">'.anchor('doublescreening/deleterecord/'.$tempID1,
                                                                                 'Delete Record', array('title' =>
                                                                                 'Record will be deleted from Table 1',
                                                                                 'class' => 'delete', 'onclick' =>
                                                                                 "return confirm('Are you sure, you want to delete this record?')"
                                                                                 )).'</p>';
        $data['title'] = "Data Entry";
        $data['contentTitle'] = "Data Screening - Choose Correct Record";
        $data['formOpen'] = form_open("doublescreening/checkedrecord");
        $data['backLink'] = anchor('dataentry/datascreening', 'Back', array('class' => 'back'));
        $data['button1'] = $skipButton.$deleteButton;
        $data['button2'] = $submitButton;
        $data['table'] = $table.$textboxNamesHD.$allRecordsHD;
        $this->load->view('user/dataentry/screentwotable', $data);
    }

    function checkedrecord() {
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/selectformtype');
        }
        $tableNames = $this->session->userdata('tableNames');
        $tableName1 = $tableNames['tableName1'];
        $tableName2 = $tableNames['tableName2'];
        $tableNameFinal = $tableNames['tableNameFinal'];
        $radioTable = $this->input->post('radioTable');
        $textboxNamesA = $this->input->post('textboxNamesA');
        $allRecordsA = $this->input->post('allRecordsA');
        $splitRadioTable = explode("_", $radioTable);
        if ($splitRadioTable[0] == 'table1') {
            $radioQuery = $this->doublescreeningmodel->fetchRecordByTempID($tableName1, $splitRadioTable[1]);
        }
        elseif ($splitRadioTable[0] == 'table2') {
            $radioQuery = $this->doublescreeningmodel->fetchRecordByTempID($tableName2, $splitRadioTable[1]);
        }
        $rowArray = $radioQuery->row_array();
        foreach ($rowArray as $rKey => $rValue) {
            if ($rKey !== $tableName1.'ID' AND $rKey !== $tableName2.'ID') {
                $insertFinalArray[$rKey] = $rValue;
                //this will get additional columns like QuadratName etc to move to final temp table
            }
        }
        //now update the array with the new values from the screening form.
        foreach ($textboxNamesA as $key => $value) {
            $insertFinalArray[$value] = $this->input->post($value."_".$radioTable);
        }
        $this->doublescreeningmodel->startTransaction();
        // Transaction Starts Here
        //Insert Selected Record in final temp table
        $this->doublescreeningmodel->insertRowIntoTable($tableNameFinal, $insertFinalArray);
        //Delete records from temp table 1 and table 2
        foreach ($allRecordsA as $key1 => $value1) {
            $splitValue1 = explode("_", $value1);
            if ($splitValue1[0] == 'table1') {
                $tempID = $splitValue1[1];
                $this->doublescreeningmodel->deleteTempRecord($tableName1, $tempID);
            }
            elseif ($splitValue1[0] == 'table2') {
                $tempID = $splitValue1[1];
                $this->doublescreeningmodel->deleteTempRecord($tableName2, $tempID);
            }
        }
        $this->doublescreeningmodel->completeTransaction();
        // Transaction Ends Here
        redirect('doublescreening/screentwotables');
    }

    function arraysDiff($array1, $array2) {
        $count = 0;
        foreach ($array1 as $key => $value) {
            if ($array1[$key] !== $array2[$key]) {
                $count++;
            }
        }
        return $count;
    }

    function skiprecord($tempID) {
        //move the first record to the last
        //change TempID
        //redirect back to screentwotables
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/selectformtype');
        }
        $tableNames = $this->session->userdata('tableNames');
        $nextTempID = $this->doublescreeningmodel->getNextTempID($tableNames['tableName1']);
        $this->doublescreeningmodel->updataTempID($tableNames['tableName1'], $tempID, $nextTempID);
        redirect('doublescreening/screentwotables');
    }

    function deleterecord($tempID) {
        //delete record in table 1 with TempID
        //redirect back to screentwotables
        if (!isset ($this->session->userdata['tableNames'])) {
            redirect('doublescreening/selectformtype');
        }
        $tableNames = $this->session->userdata('tableNames');
        $this->doublescreeningmodel->deleteTempRecord($tableNames['tableName1'], $tempID);
        redirect('doublescreening/screentwotables', 'refresh');
    }

    function _createTable($table) {
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $formName = $this->session->userdata('formName');
        $this->load->library('formlibrary');
        $configFileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName.".txt";
        $configFileName = str_replace(" ", "", $configFileName);
        $formDetailResult = $this->formlibrary->readConfigFile($configFileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$configFileName;
            die();
        }
        $this->load->library('gdelibrary');
        $processData = $this->gdelibrary->processData($formDetailResult);
        $headerListA = $processData['headerListA'];
        $columnNameA = $processData['columnNameA'];
        $columnTypeA = $processData['columnTypeA'];
        $columnDataTypeA = $processData['columnDataTypeA'];
        $createQuery = "CREATE TABLE IF NOT EXISTS `".$table."` ( `".$table."ID` int NOT NULL auto_increment, ";
        foreach ($columnNameA as $key => $value) {
            if ($columnDataTypeA[$key] == 'varchar') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` varchar(256) default NULL, ";
            }
            elseif ($columnDataTypeA[$key] == 'integer') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` int default NULL, ";
            }
            elseif ($columnDataTypeA[$key] == 'float') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` float default NULL, ";
            }
            elseif ($columnDataTypeA[$key] == 'decimal') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` decimal(24,4) default NULL, ";
            }
        }
        $createTable['createQuery'] = $createQuery."Primary Key (`".$table.
                                                                "ID`) ) ENGINE=MyISAM  DEFAULT CHARSET=latin1";
        $createTable['columnNameA'] = $columnNameA;
        $createTable['headerListA'] = $headerListA;
        return $createTable;
    }

    function _createOldTable($table) {
        $filterNameA = $filterHeaderA = $columnNameA = $headerListA = array();
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $tableName = $this->session->userdata('tableName');
        $formName = $this->session->userdata('formName');
        $this->load->library('formlibrary');
        $configFileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName."_".$tableName.".txt";
        $configFileName = str_replace(" ", "", $configFileName);
        $formDetailResult = $this->formlibrary->readConfigFile($configFileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$configFileName;
            die();
        }
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'Filter') {
                $filterResult[] = $formDetailRow;
            }
            else {
                $formResult[] = $formDetailRow;
            }
        }
        $this->load->library('oldgdelibrary');
        $createQuery = "CREATE TABLE IF NOT EXISTS `".$table."` ( `".$table."ID` int NOT NULL auto_increment, ";
        if (count($filterResult) > 0) {
            //if filters exist add filter columns first
            $processFilterData = $this->oldgdelibrary->processData($filterResult);
            $filterNameA = $processFilterData['columnNameA'];
            $filterHeaderA = $processFilterData['headerListA'];
            foreach ($filterNameA as $key => $value) {
                $createQuery = $createQuery."`".$filterNameA[$key]."` varchar(256) default NULL, ";
            }
        }
        $processData = $this->oldgdelibrary->processData($formResult);
        $columnNameA = $processData['columnNameA'];
        $headerListA = $processData['headerListA'];
        $columnDataTypeA = $processData['columnDataTypeA'];
        foreach ($columnNameA as $key => $value) {
            if (!in_array($value, $filterNameA)) {
                if ($columnDataTypeA[$key] == 'integer') {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` int default NULL, ";
                }
                elseif ($columnDataTypeA[$key] == 'float') {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` float default NULL, ";
                }
                elseif ($columnDataTypeA[$key] == 'decimal') {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` decimal(24,4) default NULL, ";
                }
                else
                // take it as varchar
                    {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` varchar(256) default NULL, ";
                }
            }
            else {
                //if the column name already exist in filters remove it from columnNameA and headerListA
                unset ($columnNameA[$key]);
                unset ($headerListA[$key]);
            }
        }
        $createTable['createQuery'] = $createQuery."Primary Key (`".$table.
                                                                "ID`) ) ENGINE=MyISAM  DEFAULT CHARSET=latin1";
        $createTable['columnNameA'] = array_merge($filterNameA, $columnNameA);
        $createTable['headerListA'] = array_merge($filterHeaderA, $headerListA);
        return $createTable;
    }

    function _createTextbox($name, $value, $textboxType) {
        $size = strlen($value);
        if ($size > 20) {
            $size = 20;
        }
        elseif ($size < 6) {
            $size = 6;
        }
        if ($textboxType == 'diff') {
            $textbxA = array('name' => $name, 'id' => $name, 'value' => $value, 'size' => $size, 'style' =>
                            'background:#FFD2D3');
        }
        else {
            $textbxA = array('name' => $name, 'id' => $name, 'value' => $value, 'size' => $size);
        }
        $textbx = form_input($textbxA);
        return $textbx;
    }

    /////////////Helper Function/////////////////
    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }
    ////////////////////////////////////////

}
