<?php

class Gdeplantform extends Controller {

    function Gdeplantform() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('formmodel');
    }

    function index() {
        if (!isset ($this->session->userdata['formName'])) {
            redirect('dataentry/formName', 'location');
        }
        $formTableA = array(array('<h4>Entry Form<h4>'), array('<span style="color:#FF0000;">Instructions: </span>'),
        array(
        "<p>- Use the * key to go from field to next.</p>
                                  <p>- Use the / key to go from field to previous.</p>
                                  <p>- When in last field use + key to add a new Stem Row</p>
                                  <p>- When in last field use [ Enter ] key to add a new Tree Row</p>
                                  <p>- Do not use special characaters (accents, etc.).</p>"
        ), array(anchor('/gdeplantform/postfix', 'Go to Entry Form', array('title' => 'Go to Entry Form', 'class' =>
        'forward'))));
        $this->table->set_empty("");
        $data['formTable'] = $this->table->generate($formTableA);
        $formName = $this->session->userdata('formName');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName
        .'</span></span>';
        $this->load->view('user/dataentry/mainmenu', $data);
    }

    function postfix() {
       if(isset($this->session->userdata['filePostfix']))
       {
         $this->session->unset_userdata('filePostfix');
       }
       $formName = $this->session->userdata('formName');

       $postfix = set_value('postfix');
       $postfixA = array('name' => 'postfix', 'id' => 'postfix', 'size' => '16', 'value' => $postfix);
       $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
       $postfixTbx = form_input($postfixA);
       $submitButton = form_button($submitButtonA);
       $postfixErr = form_error('postfix');
       $formTableA = array(array(), array('Add a post-fix to the file name: ', $postfixTbx, $postfixErr), array('',
                           '<p style="text-align:center;">'.$submitButton.'</p>'),
                           array(anchor('/gdeplantform/createform', 'Skip - Go to Entry Form', array('title'=>'Skip', 'class'=>'forward'))));
       $this->table->set_empty("");
       $data['formTable'] = $this->table->generate($formTableA);
       $data['title'] = "CTFS Generic Data Entry";
       $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.'</span></span>';
       $data['formHeading'] = "Add a post fix";
       $data['formOpen'] = form_open("gdeplantform/postfixSubmit");
       $data['backLink'] = "";

       $this->load->view('user/dataentry/simpleform', $data);
    }

    function postfixSubmit()
    {
      $postfix = $this->input->post('postfix');
      if($postfix !== '')
      {
        $this->session->set_userdata('filePostfix',$postfix);
      }
      redirect('/gdeplantform/createform');
    }


    function createform($merge = 'notMerge') {

        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $formName = $this->session->userdata('formName');
        $this->load->library('formlibrary');
        $fileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName.".txt";
        $fileName = str_replace(" ", "", $fileName);
        $formDetailResult = $this->formlibrary->readConfigFile($fileName);
        if ($formDetailResult == "Not Found") {
            $data['formTable'] = '<br /><br /><div class="error"> Configuration File Not Found!!</div>';

            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $this->load->view('user/dataentry/mainmenu', $data);
        }
        else {
            $headerListA = array();
            $rowNumber = 1;
            $columnValue = "";
            $processData = $this->_processData($formDetailResult, $rowNumber, $columnValue);
            $headerListA = $processData['headerListA'];
            $columnListA = $processData['columnListA'];
            $columnNameA = $processData['columnNameA'];
            //Create Table
            $tmpl = array('table_open' => '<table id="formtable">');
            $this->table->set_template($tmpl);
            $this->table->set_empty("&nbsp;");
            $this->table->set_heading($headerListA);
            $this->table->add_row($columnListA);
            $data['table2'] = $this->table->generate();

            $row_count = '<input type="hidden" id="row_count" name="row_count" value="1" />';
            $hiddenValues = $row_count;
            if ($merge == 'merge') {
                $data['formOpen'] = form_open("gdeplantfile/createfile/merge");
                $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' =>
                                        'Merge', 'onclick' => "return confirm('Are you sure you want to save data?')");
            }
            else {
                $data['formOpen'] = form_open("gdeplantfile/createfile/");
                $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' =>
                                        'Submit', 'onclick' => "return confirm('Are you sure you want to save data?')");
            }
            //$data['table1'] = $this->formlibrary->addTopPanel($plotID,$quadratDD,$collectedDD,$checkedDD,$enteredDD);
            /////////////////////////////////////////////////////////
            $data['title'] = "Data Entry";
            $data['contentTitle'] =
            'Entry Form - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['formHeading'] = "";
            $data['backLink'] = anchor('/gdeplantform', 'Back', array('class' => 'back'));
            $data['checkTabJS'] = $this->_createCheckTab($columnNameA);
            //CheckTab Javascript
            $data['insertRowJS'] = $this->_insertRow($formDetailResult);
            $data['submitButton'] = '<p style="text-align:center;">'.form_button($submitButtonA).'</p>';
            $data['hiddenValues'] = $hiddenValues;
            $this->load->view('treeforms/simpleform', $data);
            ///////////
        }
    }

    function _processData($formDetailResult, $rowNumber, $columnValue) {
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'text') {
                $columnDetailA = $this->_textAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA, $rowNumber, $columnValue
                );
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
            }
            elseif ($formDetailRow->ColumnType == 'limit') {
                $columnDetailA = $this->_limitAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA, $rowNumber, $columnValue
                );
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
            }
            elseif ($formDetailRow->ColumnType == 'userdd') {
                $columnDetailA = $this->_userDDAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA, $rowNumber, $columnValue
                );
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
            }
            elseif ($formDetailRow->ColumnType == 'twotext') {
                $columnDetailA = $this->_twotextAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnListA[$formDetailRow->ColumnNumber] = $this->_addColumnRow($columnDetailA, $rowNumber, $columnValue
                );
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
            }
        }
        $processData['headerListA'] = $headerListA;
        $processData['columnListA'] = $columnListA;
        $processData['columnNameA'] = $columnNameA;
        return $processData;
    }

    function _textAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['stemChange'] = $attributeA[3];
        $array ['treeChange'] = $attributeA[4];
        $array ['defaultValue'] = $attributeA[5];
        $array ['columnSize'] = $attributeA[6];
        $array ['allowNull'] = $attributeA[7];
        $array ['nextLineKey'] = $attributeA[8];
        return $array;
    }

    function _limitAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['stemChange'] = $attributeA[3];
        $array ['treeChange'] = $attributeA[4];
        $array ['upperLimit'] = $attributeA[5];
        $array ['lowerLimit'] = $attributeA[6];
        $array ['defaultValue'] = $attributeA[7];
        $array ['columnSize'] = $attributeA[8];
        $array ['allowNull'] = $attributeA[9];
        $array ['nextLineKey'] = $attributeA[10];
        return $array;
    }

    function _userDDAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['userData'] = $attributeA[2];
        if (isset ($attributeA[4]))
            //stemChange added later - for config file back compatibility
            {
            $array ['stemChange'] = $attributeA[3];
            $array ['treeChange'] = $attributeA[4];
            $array ['nextLineKey'] = $attributeA[5];
        }
        else {
            $array ['nextLineKey'] = $attributeA[3];
        }
        return $array;
    }

    function _twotextAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['stemChange'] = $attributeA[3];
        $array ['treeChange'] = $attributeA[4];
        $array ['prefix'] = $attributeA[5];
        $array ['defaultValue'] = $attributeA[6];
        $array ['columnSize'] = $attributeA[7];
        $array ['allowNull'] = $attributeA[8];
        $array ['nextLineKey'] = $attributeA[9];
        return $array;
    }

    function _addColumnRow($columnDetailA, $rowNumber, $columnValue) {
        if ($columnDetailA['columnType'] == 'text') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $columnSize = $columnDetailA['columnSize'];
            $defaultValue = $columnDetailA['defaultValue'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateNotEmpty(this)';
            }
            else {
                $onBlur = "";
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            $dataA = array('id' => $columnName, 'name' => $columnName, 'size' => $columnSize, 'value' => $defaultValue,
            'onblur' => $onBlur, 'onkeypress' => $onKeyStroke);
            $columnTbx = form_input($dataA);
            return $columnTbx;
        }
        elseif ($columnDetailA['columnType'] == 'limit') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $columnSize = $columnDetailA['columnSize'];
            $defaultValue = $columnDetailA['defaultValue'];
            $lowerLimit = $columnDetailA['lowerLimit'];
            $upperLimit = $columnDetailA['upperLimit'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateLimitNotEmpty(this,'.$lowerLimit.','.$upperLimit.')';
            }
            else {
                $onBlur = 'validateLimit(this,'.$lowerLimit.','.$upperLimit.')';
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            $dataA = array('id' => $columnName, 'name' => $columnName, 'size' => $columnSize, 'value' => $defaultValue,
            'onblur' => $onBlur, 'onkeypress' => $onKeyStroke);
            $columnTbx = form_input($dataA).'<br />';
            return $columnTbx;
        }
        elseif ($columnDetailA['columnType'] == 'userdd') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $userData = $columnDetailA['userData'];
            $userDataExplode = explode(';', $userData);
            foreach ($userDataExplode as $key => $value) {
                $userDataArray[$value] = $value;
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            $js = 'id = '.$columnName.' onkeypress = "'.$onKeyStroke.'"';
            $columnDD = form_dropdown($columnName, $userDataArray, '', $js).'<br />';
            return $columnDD;
        }
        elseif ($columnDetailA['columnType'] == 'twotext') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $prefixName = $columnDetailA['columnName']."prefix_".$rowNumber;
            $columnSize = $columnDetailA['columnSize'];
            $prefix = $columnDetailA['prefix'];
            $defaultValue = $columnDetailA['defaultValue'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateNotEmpty(this)';
            }
            else {
                $onBlur = "";
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            $prefixColumnA = array('id' => $prefixName, 'name' => $prefixName, 'size' => $columnSize, 'value' => $prefix,
            'onblur' => $onBlur, 'onkeypress' => $onKeyStroke);
            $dataA = array('id' => $columnName, 'name' => $columnName, 'size' => $columnSize, 'value' => $defaultValue,
            'onblur' => $onBlur, 'onkeypress' => $onKeyStroke);
            $columnTbx = form_input($prefixColumnA).form_input($dataA);
            return $columnTbx;
        }
    }

    //////////////////CheckTab JS/////////////////////////////
    function _createCheckTab($columnNameA) {
        $checkTabAsc = $this->_checkTabAsc($columnNameA);
        $checkTabDesc = $this->_checkTabDesc($columnNameA);
        $checkTabJS =
        '<script type="text/javascript">
                    function checkTab(e, obj) {
                   	var keynum;
                	var keychar;
                	var next;

                	if(window.event) // IE
                  	{
                  		keynum = e.keyCode;
                  	}
                	else if(e.which) // Netscape/Firefox/Opera
                  	{
                 		 keynum = e.which;
                  	}

                   if (keynum == 42) {
                        var id_arr = obj.id.split("_");'
        .$checkTabAsc.
        'return false;
                    } else if (keynum == 47) {
                        var id_arr = obj.id.split("_");'
        .$checkTabDesc.
        'return false;
                    } else if (keynum == 13) {
                        return false;
                    } else {
                		return true;
                	}
                }
                </script>';
        return $checkTabJS;
    }

    function _checkTabAsc($columnNameA) {
        $checkTabAsc = "";
        $arrayCount = count($columnNameA);
        for ($i = 1; $i < $arrayCount; $i++) {
            $columnName1 = $columnNameA[$i];
            $columnName2 = $columnNameA[$i + 1];
            if ($i == 1) {
                $checkTabAsc = $checkTabAsc.'if (id_arr[0] == "'.$columnName1.
                '")
                                {
                                document.getElementById("'.$columnName2
                .'_"+id_arr[1] ).focus();
                                }';
            }
            else {
                $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.
                '")
                                {
                                document.getElementById("'.$columnName2
                .'_"+id_arr[1] ).focus();
                                }';
            }
        }
        return $checkTabAsc;
    }

    function _checkTabDesc($columnNameA) {
        $checkTabDesc = "";
        $arrayCount = count($columnNameA);
        for ($i = $arrayCount; $i > 1; $i--) {
            $columnName1 = $columnNameA[$i];
            $columnName2 = $columnNameA[$i - 1];
            if ($i == $arrayCount) {
                $checkTabDesc = $checkTabDesc.'if (id_arr[0] == "'.$columnName1.
                '")
                                {
                                document.getElementById("'.$columnName2
                .'_"+id_arr[1] ).focus();
                                }';
            }
            else {
                $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$columnName1.
                '")
                                {
                                document.getElementById("'.$columnName2
                .'_"+id_arr[1] ).focus();
                                }';
            }
        }
        return $checkTabDesc;
    }

    /////////////////////////////////////////////////////////////////////
    ///////////////////////insertRow JS/////////////////////////////////
    function _insertRow($formDetailResult) {
        $innerHtmlStem = '';
        $innerHtmlTree = '';
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'text') {
                $columnDetailA = $this->_textAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $innerHtmlStem = $innerHtmlStem.$this->_insertRowColumns($columnDetailA, 'stem');
                $innerHtmlTree = $innerHtmlTree.$this->_insertRowColumns($columnDetailA, 'tree');
            }
            elseif ($formDetailRow->ColumnType == 'limit') {
                $columnDetailA = $this->_limitAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $innerHtmlStem = $innerHtmlStem.$this->_insertRowColumns($columnDetailA, 'stem');
                $innerHtmlTree = $innerHtmlTree.$this->_insertRowColumns($columnDetailA, 'tree');
            }
            elseif ($formDetailRow->ColumnType == 'userdd') {
                $columnDetailA = $this->_userDDAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $innerHtmlStem = $innerHtmlStem.$this->_insertRowDD($columnDetailA, "stem");
                $innerHtmlTree = $innerHtmlTree.$this->_insertRowDD($columnDetailA, "tree");
            }
            elseif ($formDetailRow->ColumnType == 'twotext') {
                $columnDetailA = $this->_twotextAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $innerHtmlStem = $innerHtmlStem.$this->_insertRowColumns($columnDetailA, 'stem');
                $innerHtmlTree = $innerHtmlTree.$this->_insertRowColumns($columnDetailA, 'tree');
            }
        }
        $insertCell = $this->_insertRowCells($columnNameA, $columnTypeA);
        $checkTabAsc = $this->_checkTabAsc($columnNameA);
        $checkTabDesc = $this->_checkTabDesc($columnNameA);
        $setFocusStem = $this->_setFocusStem($columnNameA);
        $setFocusTree = $this->_setFocusTree($columnNameA);
        $insertRow =
        '<script type="text/javascript">
                 function getKeyCode(e,obj)
                 {
                   var keynum;
	               var keychar;
	               var next;

	               if(window.event) // IE
  	               {
  		             keynum = e.keyCode;
  	               }
	               else if(e.which) // Netscape/Firefox/Opera
  	               {
 		             keynum = e.which;
  	               }

	               if (keynum == 13)// check return/enter has been pressed
                   {
		             insRow(obj.id,"tree");
		             return false;
	               }
                   else if (keynum == 43) // check plus has been pressed
                   {
		             insRow(obj.id,"stem");
		             return false;
	               }
                   else if (keynum == 42)
                   {
                     var id_arr = obj.id.split("_");'
        .$checkTabAsc.
        'return false;
                   }
                   else if (keynum == 47)
                   {
                     var id_arr = obj.id.split("_");'
        .$checkTabDesc.
        'return false;
                   }
                   else
                   {
		             return true;
	               }
                 }

                 function insRow(obj,type)
                 {
                 var id_arr = obj.split("_");
                 var currentRow = parseInt(id_arr[1]);
                 var nextRow = parseInt(id_arr[1]) + 1;

                 var table = document.getElementById("formtable");
                 var rowCount = table.rows.length;
                 var row = table.insertRow(rowCount);
                 var nextRowNo = rowCount;  /* its rows + heading so no need to add 1 */
                 '
        .$insertCell.
        '
                 if(type == "stem")
                 {
                   var num_rows = document.getElementById("row_count");
                   num_rows.value = nextRow;
                   '
        .$innerHtmlStem.'
                   '.$setFocusStem.
        '
                 }
                 else if(type == "tree")
                 {
                    var num_rows = document.getElementById("row_count");
                    num_rows.value = nextRow;
                   '
        .$innerHtmlTree.'
                   '.$setFocusTree.
        '
                 }
			     }

                 function str_pad (input, pad_length, pad_string, pad_type)
                 {
                    var half = "",
                    pad_to_go;

                    var str_pad_repeater = function (s, len)
                    {
                      var collect = "",
                      i;

                      while (collect.length < len)
                      {
                          collect += s;
                      }
                      collect = collect.substr(0, len);

                      return collect;
                    };

                    input += "";
                    pad_string = pad_string !== undefined ? pad_string : " ";

                    if (pad_type != "STR_PAD_LEFT" && pad_type != "STR_PAD_RIGHT" && pad_type != "STR_PAD_BOTH")
                    {
                      pad_type = "STR_PAD_RIGHT";
                    }
                    if ((pad_to_go = pad_length - input.length) > 0)
                    {
                     if (pad_type == "STR_PAD_LEFT")
                     {
                        input = str_pad_repeater(pad_string, pad_to_go) + input;
                     }
                     else if (pad_type == "STR_PAD_RIGHT")
                     {
                        input = input + str_pad_repeater(pad_string, pad_to_go);
                     }
                     else if (pad_type == "STR_PAD_BOTH")
                     {
                        half = str_pad_repeater(pad_string, Math.ceil(pad_to_go / 2));
                        input = half + input + half;
                        input = input.substr(0, pad_length);
                    }
                }
                return input;
                }

                function trimNumber(s)
                {
                  while (s.substr(0,1) == "0" && s.length>1)
                  {
                    s = s.substr(1,9999);
                  }
                  return s;
                }
                 </script>';
        return $insertRow;
    }

    function _insertRowCells($columnNameA, $columnTypeA) {
        $insertCell = "";
        $arrayCount = count($columnNameA);
        $arrayCount1 = count($columnNameA);
        $x = 0;
        for ($i = 1; $i <= $arrayCount; $i++) {
            $columnName = $columnNameA[$i];
            $columnType = $columnTypeA[$i];
            /*if($columnType == "twotext")
            {
            $insertCell = $insertCell.'var '.$columnName.'prefix=row.insertCell('.$x.');';
            //$x++;
            }*/
            //$j = $i-1;
            $insertCell = $insertCell.'var '.$columnName.'=row.insertCell('.$x.');';
            $x++;
        }
        return $insertCell;
    }

    function _insertRowColumns($columnDetailA, $type) {
        $columnName = $columnDetailA['columnName'];
        $columnType = $columnDetailA['columnType'];
        if ($type == 'stem') {
            if (isset ($columnDetailA['stemChange'])) {
                if ($columnDetailA['stemChange'] == 'incremented') {
                    $incrementValue = 'var current_'.$columnName.' = document.getElementById("'.$columnName.
                    '_"+currentRow).value;
                             var strCount = current_'.$columnName.
                    '.length;
                             current_'.$columnName.' = trimNumber(current_'.$columnName.
                    ');
                             var next_'.$columnName.' = parseInt(current_'.$columnName.
                    ')+ 1;
                             next_'.$columnName.' = str_pad(next_'.$columnName.
                    ', strCount,"0","STR_PAD_LEFT");';
                    $columnValue = "next_".$columnName;
                    $columnHtml = $this->_insertRowAddColumn($columnDetailA, $columnValue);
                    $column = $incrementValue.$columnHtml;
                }
                else
                    if ($columnDetailA['stemChange'] == 'carried') {
                        $carriedValue = 'var prev_'.$columnName.' = document.getElementById("'.$columnName.
                        '_"+currentRow).value;';
                        $columnValue = "prev_".$columnName;
                        $columnHtml = $this->_insertRowAddColumn($columnDetailA, $columnValue);
                        $column = $carriedValue.$columnHtml;
                    }
                    else
                    //no change - default value
                        {
                        //$columnValue = $columnDetailA['defaultValue'];
                        $column = $this->_insertRowAddColumn($columnDetailA, "defaultValue");
                }
            }
            else {
                //$columnValue = $columnDetailA['defaultValue'];
                $column = $this->_insertRowAddColumn($columnDetailA, "defaultValue");
            }
        }
        else
            if ($type == 'tree') {
                if (isset ($columnDetailA['treeChange'])) {
                    if ($columnDetailA['treeChange'] == 'incremented') {
                        $incrementValue = 'var current_'.$columnName.' = document.getElementById("'.$columnName.
                        '_"+currentRow).value;
                             var strCount = current_'.$columnName.
                        '.length;
                             current_'.$columnName.' = trimNumber(current_'.$columnName
                        .');
                             var next_'.$columnName.' = parseInt(current_'.$columnName.
                        ') + 1;
                             next_'.$columnName.' = str_pad(next_'.$columnName.
                        ', strCount,"0","STR_PAD_LEFT");';
                        $columnValue = "next_".$columnName;
                        $columnHtml = $this->_insertRowAddColumn($columnDetailA, $columnValue);
                        $column = $incrementValue.$columnHtml;
                    }
                    else
                        if ($columnDetailA['treeChange'] == 'carried') {
                            $carriedValue = 'var prev_'.$columnName.' = document.getElementById("'.$columnName.
                            '_"+currentRow).value;';
                            $columnValue = "prev_".$columnName;
                            $columnHtml = $this->_insertRowAddColumn($columnDetailA, $columnValue);
                            $column = $carriedValue.$columnHtml;
                        }
                        else
                        //no change - default value
                            {
                            //$columnValue = $columnDetailA['defaultValue'];
                            $column = $this->_insertRowAddColumn($columnDetailA, "defaultValue");
                    }
                }
                else {
                    //$columnValue = $columnDetailA['defaultValue'];
                    $column = $this->_insertRowAddColumn($columnDetailA, "defaultValue");
                }
            }
            if ($columnType == 'twotext') {
                $prefixValue = 'var prefix_'.$columnName.' = document.getElementById("'.$columnName.
                'prefix_"+currentRow).value;';
                //Carry over the prefix column value to the next row
                $column = $prefixValue.$column;
            }
            return $column;
    }

    function _insertRowAddColumn($columnDetailA, $columnValue) {
        if ($columnDetailA['columnType'] == 'text') {
            $columnName = $columnDetailA['columnName'];
            $columnSize = $columnDetailA['columnSize'];
            $defaultValue = $columnDetailA['defaultValue'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateNotEmpty(this)';
            }
            else {
                $onBlur = "";
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            if ($columnValue == "defaultValue") {
                $columnValue = $defaultValue;
                $columnTbx = $columnName.'.innerHTML = \'<input type="text" name="'.$columnName.
                '_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="'.$columnValue.
                '" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
            }
            //$columnTbx = $columnName.'.innerHTML = \'<input type="text" name="\''.$columnName.'_"\'+nextRowNo+\' id="\''.$columnName.'\'_"\'+nextRowNo+\' size=\''.$columnSize.'\' value=\'+'.$columnValue.'+\' onkeypress="return checkTab(event,this);"/>\';';
            else {
                $columnTbx = $columnName.'.innerHTML = \'<input type="text" name="'.$columnName.
                '_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="\'+'.$columnValue.
                '+\'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
            }
            return $columnTbx;
        }
        elseif ($columnDetailA['columnType'] == 'limit') {
            $columnName = $columnDetailA['columnName'];
            $columnSize = $columnDetailA['columnSize'];
            $defaultValue = $columnDetailA['defaultValue'];
            $lowerLimit = $columnDetailA['lowerLimit'];
            $upperLimit = $columnDetailA['upperLimit'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateLimitNotEmpty(this,'.$lowerLimit.','.$upperLimit.')';
            }
            else {
                $onBlur = 'validateLimit(this,'.$lowerLimit.','.$upperLimit.')';
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            //$columnTbx = $columnName.".innerHTML = \"<input type='text' name='".$columnName."'_+nextRowNo+' id='".$columnName."_+nextRowNo+' size=".$columnSize." value='".$columnValue."' onkeypress='return checkTab(event,this);'/>\";";
            if ($columnValue == "defaultValue") {
                $columnValue = $defaultValue;
                $columnTbx = $columnName.'.innerHTML = \'<input type="text" name="'.$columnName.
                '_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="'.$columnValue.
                '" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
            }
            else {
                $columnTbx = $columnName.'.innerHTML = \'<input type="text" name="'.$columnName.
                '_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="\'+'.$columnValue.
                '+\'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
            }
            //$columnTbx = '<input type='.'"text"'.' name="'.$columnName.'_+nextRowNo+" id="'.$columnName.'_+nextRowNo+" size='.$columnSize.' value="'.$columnValue.'" onkeypress="return checkTab(event,this);">';
            return $columnTbx;
        }
        elseif ($columnDetailA['columnType'] == 'twotext') {
            $columnName = $columnDetailA['columnName'];
            $prefixName = $columnDetailA['columnName']."prefix";
            $columnSize = $columnDetailA['columnSize'];
            //$prefix = $columnDetailA['prefix'];
            $prefix = 'prefix_'.$columnName;
            $defaultValue = $columnDetailA['defaultValue'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateNotEmpty(this)';
            }
            else {
                $onBlur = "";
            }
            if ($columnDetailA['nextLineKey'] == 'no') {
                $onKeyStroke = 'return checkTab(event,this);';
            }
            else {
                $onKeyStroke = 'return getKeyCode(event,this);';
            }
            if ($columnValue == "defaultValue") {
                $columnValue = $defaultValue;
                //$columnTbx1 = $prefixName.'.innerHTML = \'<input type="text" name="'.$prefixName.'_\'+nextRowNo+\'" id= "'.$prefixName.'_\'+nextRowNo+\'" size='.$columnSize.' value="'.$prefix.'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
                $columnTbx = $columnName.'.innerHTML = \'<input type="text" name="'.$prefixName.
                '_\'+nextRowNo+\'" id= "'.$prefixName.'_\'+nextRowNo+\'" size='.$columnSize.' value="\'+'.$prefix.
                '+\'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/> <input type="text" name="'.$columnName.
                '_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="'.$columnValue.
                '" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/> \';';
            }
            //$columnTbx = $columnName.'.innerHTML = \'<input type="text" name="\''.$columnName.'_"\'+nextRowNo+\' id="\''.$columnName.'\'_"\'+nextRowNo+\' size=\''.$columnSize.'\' value=\'+'.$columnValue.'+\' onkeypress="return checkTab(event,this);"/>\';';
            else {
                //$columnTbx1 = $prefixName.'.innerHTML = \'<input type="text" name="'.$prefixName.'_\'+nextRowNo+\'" id= "'.$prefixName.'_\'+nextRowNo+\'" size='.$columnSize.' value="'.$prefix.'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
                //$columnTbx2 = $columnName.'.innerHTML = \'<input type="text" name="'.$columnName.'_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="'.$columnValue.'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
                $columnTbx = $columnName.'.innerHTML = \'<input type="text" name="'.$prefixName.
                '_\'+nextRowNo+\'" id= "'.$prefixName.'_\'+nextRowNo+\'" size='.$columnSize.' value="\'+'.$prefix.
                '+\'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/> <input type="text" name="'.$columnName.
                '_\'+nextRowNo+\'" id= "'.$columnName.'_\'+nextRowNo+\'" size='.$columnSize.' value="\'+'.$columnValue.
                '+\'" onblur="'.$onBlur.'" onkeypress="'.$onKeyStroke.'"/>\';';
            }
            //$columnTbx = $columnTbx1.$columnTbx2;
            return $columnTbx;
        }
    }

    function _insertRowDD($columnDetailA, $type) {
        $columnName = $columnDetailA['columnName'];
        if ($type == 'stem') {
            if (isset ($columnDetailA['stemChange'])) {
                if ($columnDetailA['stemChange'] == 'carried') {
                    $insertRowDD = 'var '.$columnName.'Obj = document.getElementById("'.$columnName.
                    '_1");
                     new'.$columnName.'DD = '.$columnName.
                    'Obj.cloneNode(true);
                     new'.$columnName.'DD.id = "'.$columnName.
                    '_"+(nextRowNo);
			         new'.$columnName.'DD.name = "'.$columnName.
                    '_"+(nextRowNo);
                     var '.$columnName.'PrevObj = document.getElementById("'.$columnName
                    .'_"+(nextRowNo - 1));
                     if('.$columnName.
                    'PrevObj != null)
                     {
			  		  var '.$columnName.'Index = '.$columnName.
                    'PrevObj.selectedIndex;
					  new'.$columnName.'DD.selectedIndex = '.$columnName.
                    'Index;
                     }
                     '.$columnName.'.appendChild(new'.$columnName.
                    'DD);';
                }
                else {
                    $insertRowDD = 'var '.$columnName.'Obj = document.getElementById("'.$columnName.
                    '_1");
                     new'.$columnName.'DD = '.$columnName.
                    'Obj.cloneNode(true);
                     new'.$columnName.'DD.id = "'.$columnName.
                    '_"+(nextRowNo);
			         new'.$columnName.'DD.name = "'.$columnName.
                    '_"+(nextRowNo);
                     var '.$columnName.'PrevObj = document.getElementById("'.$columnName
                    .'_"+(nextRowNo - 1));
                     '.$columnName.'.appendChild(new'.$columnName.'DD);';
                }
            }
            else {
                $insertRowDD = 'var '.$columnName.'Obj = document.getElementById("'.$columnName.
                '_1");
                     new'.$columnName.'DD = '.$columnName.
                'Obj.cloneNode(true);
                     new'.$columnName.'DD.id = "'.$columnName.
                '_"+(nextRowNo);
			         new'.$columnName.'DD.name = "'.$columnName.
                '_"+(nextRowNo);
                     var '.$columnName.'PrevObj = document.getElementById("'.$columnName
                .'_"+(nextRowNo - 1));
                     '.$columnName.'.appendChild(new'.$columnName.'DD);';
            }
        }
        else {
            if (isset ($columnDetailA['treeChange'])) {
                if ($columnDetailA['treeChange'] == 'carried') {
                    $insertRowDD = 'var '.$columnName.'Obj = document.getElementById("'.$columnName.
                    '_1");
                     new'.$columnName.'DD = '.$columnName.
                    'Obj.cloneNode(true);
                     new'.$columnName.'DD.id = "'.$columnName.
                    '_"+(nextRowNo);
			         new'.$columnName.'DD.name = "'.$columnName.
                    '_"+(nextRowNo);
                     var '.$columnName.'PrevObj = document.getElementById("'.$columnName
                    .'_"+(nextRowNo - 1));
                     if('.$columnName.
                    'PrevObj != null)
                     {
			  		  var '.$columnName.'Index = '.$columnName.
                    'PrevObj.selectedIndex;
					  new'.$columnName.'DD.selectedIndex = '.$columnName.
                    'Index;
                     }
                     '.$columnName.'.appendChild(new'.$columnName.
                    'DD);';
                }
                else {
                    $insertRowDD = 'var '.$columnName.'Obj = document.getElementById("'.$columnName.
                    '_1");
                     new'.$columnName.'DD = '.$columnName.
                    'Obj.cloneNode(true);
                     new'.$columnName.'DD.id = "'.$columnName.
                    '_"+(nextRowNo);
			         new'.$columnName.'DD.name = "'.$columnName.
                    '_"+(nextRowNo);
                     var '.$columnName.'PrevObj = document.getElementById("'.$columnName
                    .'_"+(nextRowNo - 1));
                     '.$columnName.'.appendChild(new'.$columnName.'DD);';
                }
            }
            else {
                $insertRowDD = 'var '.$columnName.'Obj = document.getElementById("'.$columnName.
                '_1");
                     new'.$columnName.'DD = '.$columnName.
                'Obj.cloneNode(true);
                     new'.$columnName.'DD.id = "'.$columnName.
                '_"+(nextRowNo);
			         new'.$columnName.'DD.name = "'.$columnName.
                '_"+(nextRowNo);
                     var '.$columnName.'PrevObj = document.getElementById("'.$columnName
                .'_"+(nextRowNo - 1));
                     '.$columnName.'.appendChild(new'.$columnName.'DD);';
            }
        }
        return $insertRowDD;
    }

    function _setFocusStem($columnNameA) {
        $setFocusStem = "";
        $arrayCount = count($columnNameA);
        for ($i = 1; $i <= $arrayCount; $i++) {
            $columnName = $columnNameA[$i];
            if ($i == 1) {
                $setFocusStem = $setFocusStem.'if (document.getElementById("'.$columnName.
                '_"+nextRowNo).value == "")
                                {
                                document.getElementById("'
                .$columnName.'_"+nextRowNo ).focus();
                                }';
            }
            else {
                $setFocusStem = $setFocusStem.'else if (document.getElementById("'.$columnName.
                '_"+nextRowNo).value == "")
                                {
                                document.getElementById("'
                .$columnName.'_"+nextRowNo ).focus();
                                }';
            }
        }
        return $setFocusStem;
    }

    function _setFocusTree($columnNameA) {
        $columnName = $columnNameA[1];
        $setFocusTree = 'document.getElementById("'.$columnName.'_"+nextRowNo ).focus();';
        return $setFocusTree;
    }
    ///////////////////////////////////////////////////////////////////////

}
