<?php

class Oldentryfile extends Controller {

    function Oldentryfile() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->helper('text');
        set_time_limit(0);
        ini_set('memory_limit', '-1');
    }

    function createfile() {
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $formName = $this->session->userdata('formName');
        $tableName = $this->session->userdata('tableName');
        $username = $this->session->userdata('username');
        $this->load->library('formlibrary');
        $configFileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName."_".$tableName.".txt";
        $configFileName = str_replace(" ", "", $configFileName);
        $formDetailResult = $this->formlibrary->readConfigFile($configFileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$configFileName;
            die();
        }
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'Filter') {
                $filterResult[] = $formDetailRow;
            }
            else {
                $formResult[] = $formDetailRow;
            }
        }
        $this->load->library('oldgdelibrary');
        $processData = $this->oldgdelibrary->processData($formResult);
        $columnNameA = $processData['columnNameA'];
        $recordsNum = $this->input->post('row_count');
        $this->load->helper('date');
        $datestring = "%m-%d-%Y";
        $date = mdate($datestring);
        $timestring = "%H %i %s";
        $time = mdate($timestring);
        if(isset($this->session->userdata['filePostfix']))
        {
          $postfix = $this->session->userdata('filePostfix');
          $filename = join('_', array($formName, $selectedPlotName, $username, $date, $time, $postfix));
        }
        else
        {
          $filename = join('_', array($formName, $selectedPlotName, $username, $date, $time));
        }
        //$random = rand(1,99);
        $filename = str_replace(" ", "", $filename);
        $filterLine = '';
        $filterNumber = 1;
        if (isset ($this->session->userdata['filterValues'])) {
            $filterValues = $this->session->userdata('filterValues');
            foreach ($filterValues as $key => $val) {
                if ($filterNumber == 1) {
                    $filterLine = $key."$$".$val;
                    $filterNumber++;
                }
                else {
                    $filterLine = $filterLine."\t".$key."$$".$val;
                    $filterNumber++;
                }
            }
        }
        $linetab = "\t";
        $nextline = "\r\n";
        $this->load->helper('file');
        /////////filters//////////
        write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $filterLine, 'w');
        write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $nextline, 'a');
        //////////////////////////////
        /////////column names//////////
        $dataJoin = join("\t", $columnNameA);
        write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $dataJoin, 'a');
        //////////////////////////////
        ///////column data//////////
        for ($i = 1; $i <= $recordsNum; $i++) {
            $columnCount = count($columnNameA);
            //columnNameA keys are columnNumber
            write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $nextline, 'a');
            for ($x = 1; $x <= $columnCount; $x++) {
                $columnName = $columnNameA[$x];
                $columnValue = $this->input->post($columnName."_".$i);
                write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $columnValue, 'a');
                write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $linetab, 'a');
            }
        }
        $filepath = base_url().'files/datafiles/gdedatafile/'.$filename.'.txt';
        if ($this->fileExists($filepath)) {
            $fileLink = anchor($filepath, $filename.'.txt', array('title' => 'View Text File', 'target' => '_blank'));
            $data['formTable'] = '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
        }
        else {
            $data['formTable'] = '<div class="error">Error Occured while Creating File.</div>';
        }
        $data['formOpen'] = "";
        $formName = $this->session->userdata('formName');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName
        .'</span></span>';
        $data['backLink'] = anchor('dataentry/mainmenu/', 'Back', array('title' => 'Back to Select Form Type', 'class'
                                  => 'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function fileExists($path) {
        return (@ fopen($path, "r") == true);
    }

}
