<?php
if (!defined('BASEPATH'))
    exit ('No direct script access allowed');

class Oldgdelibrary {

    function processData($formDetailResult) {
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'Old' || $formDetailRow->ColumnType == 'Filter') {
                $columnDetailA = $this->_sortOldFormData($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = 'varchar';
            }
            elseif ($formDetailRow->ColumnType == 'text') {
                $columnDetailA = $this->_textAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['dataType'];
            }
            elseif ($formDetailRow->ColumnType == 'limit') {
                $columnDetailA = $this->_limitAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['dataType'];
            }
            elseif ($formDetailRow->ColumnType == 'userdd') {
                $columnDetailA = $this->_userddAttributes($formDetailRow->Attributes);
                $columnDetailA['columnNumber'] = $formDetailRow->ColumnNumber;
                $columnDetailA['columnType'] = $formDetailRow->ColumnType;
                $headerListA[$formDetailRow->ColumnNumber] = $columnDetailA['columnHeader'];
                $columnNameA[$formDetailRow->ColumnNumber] = $columnDetailA['columnName'];
                $columnTypeA[$formDetailRow->ColumnNumber] = $columnDetailA['columnType'];
                $columnDataTypeA[$formDetailRow->ColumnNumber] = 'varchar';
            }
        }
        $processData['headerListA'] = $headerListA;
        $processData['columnNameA'] = $columnNameA;
        $processData['columnTypeA'] = $columnTypeA;
        $processData['columnDataTypeA'] = $columnDataTypeA;
        return $processData;
    }

    function _sortOldFormData($attributes) {
        $attributesList = explode("\t", $attributes);
        $attributesArray['columnHeader'] = $attributesList[0];
        $attributesArray['columnName'] = $attributesList[1];
        $attributesArray['columnSize'] = $attributesList[2];
        return $attributesArray;
    }

    function _textAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['defaultValue'] = $attributeA[3];
        $array ['columnSize'] = $attributeA[4];
        $array ['allowNull'] = $attributeA[5];
        return $array;
    }

    function _limitAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['upperLimit'] = $attributeA[3];
        $array ['lowerLimit'] = $attributeA[4];
        $array ['defaultValue'] = $attributeA[5];
        $array ['columnSize'] = $attributeA[6];
        $array ['allowNull'] = $attributeA[7];
        return $array;
    }

    function _userddAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['userData'] = $attributeA[2];
        return $array;
    }

}
