<?php

class Gdedataupload extends Controller {

    function Gdedataupload() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('gdedatauploadmodel');
        global $databaseName;
        $databaseName = $this->session->userdata('databaseName');
        set_time_limit(0);
        ini_set('memory_limit', '-1');
    }

    function uploadall() {
        if (!isset ($this->session->userdata['formType'])) {
            redirect('dataentry/formType', 'location');
        }
        $formType = $this->session->userdata('formType');
        $this->gdedatauploadmodel->startTransaction();
        // Transaction Starts Here
        $formName = $this->session->userdata('formName');
        $dir = "./files/datafiles/gdedatafile/";
        //upload all the files from selected form type folder
        if (is_dir($dir)) {
            if ($dh = opendir($dir)) {
                if ($formType == 'Old') {
                    $createTable = $this->_createOldTable();
                }
                else {
                    $createTable = $this->_createTable();
                }
                $createQuery = $createTable['createQuery'];
                $columnNameA = $createTable['columnNameA'];
                $this->gdedatauploadmodel->executeQuery($createQuery);
                while (($file = readdir($dh)) !== false) {
                    if ($file !== "." && $file !== "..") {
                        //Read the file content and upload to the temp table.
                        $fileSplit = explode(".", $file);
                        $file = $fileSplit[0];
                        // Remove .txt from the end - need to remove for dropdown
                        $fileSplit1 = explode("_", $file);
                        if ($fileSplit1[0] == $formName) {
                            if ($formType == 'Old') {
                                $this->_uploadOldFile($formName, $file, $columnNameA);
                            }
                            else {
                                $this->_uploadFile($formName, $file, $columnNameA);
                            }
                            $this->_moveuploadedfile($file);
                        }
                    }
                }
                closedir($dh);
            }
        }
        $transactionStatus = $this->gdedatauploadmodel->completeTransaction();
        if ($transactionStatus == 'Success') {
            $data['formTable'] = '<div class="success">The Data Uploaded Successfully.</div>';
        }
        else {
            $data['formTable'] = '<div class="error">Error Occured while uploading.</div>';
        }
        $data['formOpen'] = "";
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Data Uploading - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span></span>';
        $data['backLink'] = anchor('/dataentry/uploaddata', 'Back', array('title' => 'Back to Upload Menu', 'class' =>
                                  'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function uploadselect() {
        if (!isset ($this->session->userdata['formType'])) {
            redirect('dataentry/formType', 'location');
        }
        $formName = $this->session->userdata('formName');
        $data['formOpen'] = form_open("gdedataupload/uploadselectvalidate");
        $fileNameArray = $this->_getFileNameArray($formName);
        $data['formTable'] = $this->_selectFileTable($fileNameArray);
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Select File - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.
        $formName.'</span></span>';
        $data['backLink'] = anchor('/dataentry/uploaddata', 'Back', array('title' => 'Back to Upload Menu', 'class' =>
                                  'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function uploadselectvalidate() {
        if (!isset ($this->session->userdata['formType'])) {
            redirect('dataentry/formType', 'location');
        }
        $formType = $this->session->userdata('formType');
        $this->_validateUploadSelect();
        $formName = $this->session->userdata('formName');
        $fileNameArray = $this->_getFileNameArray($formName);
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_selectFileTable($fileNameArray);
            $data['formOpen'] = form_open("gdedataupload/uploadselectvalidate");
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'Select Merge File - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['backLink'] = anchor('/dataentry/uploaddata', 'Back', array('title' => 'Back to Upload Menu', 'class'
                                      => 'back'));
            $this->load->view('user/dataentry/simpleform', $data);
        }
        else {
            $this->gdedatauploadmodel->startTransaction();
            // Transaction Starts Here
            $fileName = $this->input->post('fileName');
            if ($formType == 'Old') {
                $createTable = $this->_createOldTable();
                $createQuery = $createTable['createQuery'];
                $columnNameA = $createTable['columnNameA'];
                $filterNameA = $createTable['filterNameA'];
                $this->gdedatauploadmodel->executeQuery($createQuery);
                $this->_uploadOldFile($formName, $fileName, $columnNameA);
            }
            else {
                $createTable = $this->_createTable();
                $createQuery = $createTable['createQuery'];
                $columnNameA = $createTable['columnNameA'];
                $this->gdedatauploadmodel->executeQuery($createQuery);
                $this->_uploadFile($formName, $fileName, $columnNameA);
            }
            $transactionStatus = $this->gdedatauploadmodel->completeTransaction();
            if ($transactionStatus == 'Success') {
                $this->_moveuploadedfile($fileName);
                $data['formTable'] = '<div class="success">The Data Uploaded Successfully.</div>';
            }
            else {
                $data['formTable'] = '<div class="error">Error Occured while uploading.</div>';
            }
            $data['formOpen'] = "";
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'Data Uploading - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['backLink'] = anchor('/dataentry/uploaddata', 'Back', array('title' => 'Back to Upload Menu', 'class'
                                      => 'back'));
            $this->load->view('user/dataentry/simpleform', $data);
        }
    }

    function _getFileNameArray($formName) {
        $dir = "./files/datafiles/gdedatafile/";
        //form with drop down - listing files in the selected form type folder
        if (is_dir($dir)) {
            if ($dh = opendir($dir)) {
                $fileNameArray = array();
                //$fileNameArray['default'] = 'No Files In Folder';
                while (($file = readdir($dh)) !== false) {
                    if ($file !== "." && $file !== "..") {
                        $fileSplit = explode(".", $file);
                        $file = $fileSplit[0];
                        // Remove .txt from the end - need to remove for dropdown
                        $fileSplit1 = explode("_", $file);
                        if ($fileSplit1[0] == $formName) {
                            $fileNameArray[$file] = $file;
                        }
                        $fileNameArray['default'] = 'Select';
                    }
                }
                natcasesort($fileNameArray);
                $defaultArray = array('default' => 'Select');
                $fileNameArray = array_merge($defaultArray, $fileNameArray);
                closedir($dh);
            }
        }
        else {
            $fileNameArray = array('default' => 'Unable Access Dir');
        }
        return $fileNameArray;
    }

    function _selectFileTable($fileNameArray) {
        $fileName = set_value('fileName');
        $fileNameDD = form_dropdown('fileName', $fileNameArray);
        //$fileNameHd = form_hidden('fileNameArray',$fileNameArray);
        //$formTypeHd = form_hidden('formType',$formType);
        $fileNameErr = form_error('fileName');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array(), array('Select File : ', $fileNameDD, $fileNameErr), array('', $submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateUploadSelect() {
        $this->form_validation->set_rules('fileName', 'File', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

    function _uploadFile($formName, $fileName, $columnNameA) {
        $dir = "./files/datafiles/gdedatafile/";
        $file = $dir.$fileName.'.txt';
        $this->load->library('formlibrary');
        $fileContent = $this->formlibrary->readGdeDataFile($file);
        if ($fileContent == "Not Found") {
            echo "Unable to extract data  :  ".$file;
            die();
        }
        $contentA = $fileContent['content'];
        $contentInsertArray = array();
        foreach ($contentA as $contentRow) {
            foreach ($columnNameA as $key => $value) {
                if (isset ($contentRow->$value)) {
                    $insertValue = $contentRow->$value;
                    if ($insertValue == '') {
                        $insertValue = NULL;
                        //set the value Null if the column is left blank
                    }
                    $contentInsertArray[$value] = $insertValue;
                }
            }
            $tempTableName = $formName;
            $this->gdedatauploadmodel->insertRowIntoTable($tempTableName, $contentInsertArray);
        }
    }

    function _uploadOldFile($formName, $fileName, $columnNameA) {
        $dir = "./files/datafiles/gdedatafile/";
        $file = $dir.$fileName.'.txt';
        $this->load->library('formlibrary');
        $fileContent = $this->formlibrary->readOldGdeDataFile($file);
        if ($fileContent == "Not Found") {
            echo "Unable to extract data  :  ".$file;
            die();
        }
        $contentA = $fileContent['content'];
        $filterData = $fileContent['filterData'];
        $contentInsertArray = array();
        if (count($filterData) > 0) {
            foreach ($filterData as $filterInfo) {
                $filterInfoSplit = explode("$$", $filterInfo);
                $filterName = $filterInfoSplit[0];
                $filterValue = $filterInfoSplit[1];
                $contentInsertArray[$filterName] = $filterValue;
            }
        }
        foreach ($contentA as $contentRow) {
            foreach ($columnNameA as $key => $value) {
                if (isset ($contentRow->$value)) {
                    $insertValue = $contentRow->$value;
                    if ($insertValue == '') {
                        $insertValue = NULL;
                        //set the value Null if the column is left blank
                    }
                    $contentInsertArray[$value] = $insertValue;
                }
            }
            $tempTableName = $formName;
            $this->gdedatauploadmodel->insertRowIntoTable($tempTableName, $contentInsertArray);
        }
    }

    function _createTable() {
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $formName = $this->session->userdata('formName');
        $this->load->library('formlibrary');
        $configFileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName.".txt";
        $configFileName = str_replace(" ", "", $configFileName);
        $formDetailResult = $this->formlibrary->readConfigFile($configFileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$configFileName;
            die();
        }
        $this->load->library('gdelibrary');
        $processData = $this->gdelibrary->processData($formDetailResult);
        $headerListA = $processData['headerListA'];
        $columnNameA = $processData['columnNameA'];
        $columnTypeA = $processData['columnTypeA'];
        $columnDataTypeA = $processData['columnDataTypeA'];
        $createQuery = "CREATE TABLE IF NOT EXISTS `".$formName."` ( `".$formName."ID` int NOT NULL auto_increment, ";
        foreach ($columnNameA as $key => $value) {
            if ($columnDataTypeA[$key] == 'varchar') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` varchar(256) default NULL, ";
            }
            elseif ($columnDataTypeA[$key] == 'integer') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` int default NULL, ";
            }
            elseif ($columnDataTypeA[$key] == 'float') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` float default NULL, ";
            }
            elseif ($columnDataTypeA[$key] == 'decimal') {
                $createQuery = $createQuery."`".$columnNameA[$key]."` decimal(24,4) default NULL, ";
            }
        }
        $createTable['createQuery'] = $createQuery."Primary Key (`".$formName.
                                                                "ID`) ) ENGINE=MyISAM  DEFAULT CHARSET=latin1";
        $createTable['columnNameA'] = $columnNameA;
        return $createTable;
    }

    function _createOldTable() {
        $filterNameA = array();
        $columnNameA = array();
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $tableName = $this->session->userdata('tableName');
        $formName = $this->session->userdata('formName');
        $this->load->library('formlibrary');
        $configFileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName."_".$tableName.".txt";
        $configFileName = str_replace(" ", "", $configFileName);
        $formDetailResult = $this->formlibrary->readConfigFile($configFileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$configFileName;
            die();
        }
        foreach ($formDetailResult as $formDetailRow) {
            if ($formDetailRow->ColumnType == 'Filter') {
                $filterResult[] = $formDetailRow;
            }
            else {
                $formResult[] = $formDetailRow;
            }
        }
        $this->load->library('oldgdelibrary');
        $createQuery = "CREATE TABLE IF NOT EXISTS `".$formName."` ( `".$formName."ID` int NOT NULL auto_increment, ";
        if (count($filterResult) > 0) {
            //if filters exist add filter columns first
            $processFilterData = $this->oldgdelibrary->processData($filterResult);
            $filterNameA = $processFilterData['columnNameA'];
            foreach ($filterNameA as $key => $value) {
                $createQuery = $createQuery."`".$filterNameA[$key]."` varchar(256) default NULL, ";
            }
        }
        $processData = $this->oldgdelibrary->processData($formResult);
        $columnNameA = $processData['columnNameA'];
        $columnDataTypeA = $processData['columnDataTypeA'];
        foreach ($columnNameA as $key => $value) {
            if (!in_array($value, $filterNameA)) {
                if ($columnDataTypeA[$key] == 'integer') {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` int default NULL, ";
                }
                elseif ($columnDataTypeA[$key] == 'float') {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` float default NULL, ";
                }
                elseif ($columnDataTypeA[$key] == 'decimal') {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` decimal(24,4) default NULL, ";
                }
                else
                // take it as varchar
                    {
                    $createQuery = $createQuery."`".$columnNameA[$key]."` varchar(256) default NULL, ";
                }
            }
            else {
                //if the column name already exist in filters remove it from columnNameA
                unset ($columnNameA[$key]);
            }
        }
        $createTable['createQuery'] = $createQuery."Primary Key (`".$formName.
                                                                "ID`) ) ENGINE=MyISAM  DEFAULT CHARSET=latin1";
        $createTable['columnNameA'] = $columnNameA;
        $createTable['filterNameA'] = $filterNameA;
        return $createTable;
    }

    function _moveuploadedfile($fileName) {
        $dir = "./files/datafiles/gdedatafile/";
        $dirMove = "./files/datafiles/uploaded/gdedatafile/";
        $fileNameMove = $fileName;
        $fileName = $dir.$fileName.".txt";
        //complete path to file
        $fileNameMove = $dirMove.$fileNameMove.".txt";
        copy($fileName, $fileNameMove);
        //copy file
        $this->fileExists($fileNameMove);
        //to make sure file is copied to other folder
        {
            unlink($fileName);
            //delete file
        }
    }

    function fileExists($path) {
        return (@ fopen($path, "r") == true);
    }

}
