<?php

class Gdeplantfile extends Controller {

    function Gdeplantfile() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->helper('text');
        set_time_limit(0);
        ini_set('memory_limit', '-1');
    }

    function createfile($merge = 'notMerge') {
        $selectedPlotName = $this->session->userdata('selectedPlotName');
        $formName = $this->session->userdata('formName');
        $username = $this->session->userdata('username');
        $this->load->library('formlibrary');
        $configFileName = base_url()."files/configfiles/".$formName."_".$selectedPlotName.".txt";
        $configFileName = str_replace(" ", "", $configFileName);
        $formDetailResult = $this->formlibrary->readConfigFile($configFileName);
        if ($formDetailResult == "Not Found") {
            echo "Configuration File Not Found  :  ".$configFileName;
            die();
        }
        $this->load->library('gdelibrary');
        $processData = $this->gdelibrary->processData($formDetailResult);
        $headerListA = $processData['headerListA'];
        $columnNameA = $processData['columnNameA'];
        $columnTypeA = $processData['columnTypeA'];
        $recordsNum = $this->input->post('row_count');
        if ($merge == 'merge') {
            $filename = $this->session->userdata('mergefilename');
        }
        else {
            $this->load->helper('date');
            $datestring = "%m-%d-%Y";
            $date = mdate($datestring);
            $timestring = "%H %i %s";
            $time = mdate($timestring);
            //$random = rand(1,99);
            if(isset($this->session->userdata['filePostfix']))
            {
              $postfix = $this->session->userdata('filePostfix');
              $filename = join('_', array($formName, $selectedPlotName, $username, $date, $time, $postfix));
            }
            else
            {
              $filename = join('_', array($formName, $selectedPlotName, $username, $date, $time));
            }
            $filename = str_replace(" ", "", $filename);
        }
        $linetab = "\t";
        $nextline = "\r\n";
        $this->load->helper('file');
        if ($merge == 'merge') {
            //don't add header data
        }
        else {
            /////////column names//////////
            $dataJoin = join("\t", $columnNameA);
            write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $dataJoin, 'w');
            //////////////////////////////
            //write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $nextline,'a');
        }
        ///////column data//////////
        for ($i = 1; $i <= $recordsNum; $i++) {
            $columnCount = count($columnNameA);
            //columnNameA keys are columnNumber
            write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $nextline, 'a');
            for ($x = 1; $x <= $columnCount; $x++) {
                $columnName = $columnNameA[$x];
                $columnType = $columnTypeA[$x];
                if ($columnType == 'twotext') {
                    $columnValue1 = $this->input->post($columnName."prefix_".$i);
                    $columnValue2 = $this->input->post($columnName."_".$i);
                    $columnValue = $columnValue1.$columnValue2;
                }
                else {
                    $columnValue = $this->input->post($columnName."_".$i);
                }
                write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $columnValue, 'a');
                write_file('./files/datafiles/gdedatafile/'.$filename.'.txt', $linetab, 'a');
            }
        }
        $filepath = base_url().'files/datafiles/gdedatafile/'.$filename.'.txt';
        if ($this->fileExists($filepath)) {
            $fileLink = anchor($filepath, $filename.'.txt', array('title' => 'View Text File', 'target' => '_blank'));
            $data['formTable'] = '<div class="success">The File Created Successfully - '.$fileLink.'</div>';
        }
        else {
            $data['formTable'] = '<div class="error">Error Occured while Creating File.</div>';
        }
        $data['formOpen'] = "";
        $formName = $this->session->userdata('formName');
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] = 'Data Entry - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName
        .'</span></span>';
        $data['backLink'] = anchor('dataentry/mainmenu/', 'Back', array('title' => 'Back to Select Form Type', 'class'
                                  => 'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function fileExists($path) {
        return (@ fopen($path, "r") == true);
    }

}
