<?php


class Oldform extends Controller {


    function Oldform() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        $this->load->model('formmodel');
    }


    function preview() {
        if (isset ($this->session->userdata['filterValues'])) {
            $this->session->unset_userdata('filterValues');
        }
        redirect('oldform/createform');
    }


    function createform() {
        if (isset ($this->session->userdata['filterArgs'])) {
            $this->session->unset_userdata('filterArgs');
        }
        $checkTabA = array();
        $orderBy = "";
        $formName = $this->session->userdata('formName');
        $formType = $this->session->userdata('formType');
        $databaseName = $this->session->userdata('selectedPlotName');
        $this->load->model('configmodel');
        $filterQuery = $this->configmodel->getFilterDataByFormName($databaseName, $formName,
                                                                  $formType);
        //Create Table
        $tmpl = array('table_open' => '<table id="formtable">');
        $this->table->set_template($tmpl);
        $this->table->set_empty("&nbsp;");
        
        if ($filterQuery->num_rows() > 0) {
            $filterResult = $filterQuery->result();
            foreach ($filterResult as $filterRow) {
                $tableName = $filterRow->TableName;
                $columnNumber = $filterRow->ColumnNumber;
                $attributes = $filterRow->Attributes;
                $filterAttributes = $this->_processOld($attributes);
                $columnHeader = $filterAttributes['columnHeader'];
                $columnName = $filterAttributes['columnName'];
                if (isset ($this->session->userdata['filterValues'])) {
                    $filterValues = $this->session->userdata('filterValues');
                }
                else {
                    $filterValues = array();
                }
                if (!isset ($filterValues[$columnName])) {
                    $filterArgs = array('columnHeader' => $columnHeader, 'columnName' => $columnName,
                                       'tableName' => $tableName, 'filterValues' => $filterValues
                                       );
                    $this->session->set_userdata('filterArgs', $filterArgs);
                    redirect('oldform/filter');
                }
            }
        }
        if (isset ($this->session->userdata['filterValues'])) {
            $filterValues = $this->session->userdata('filterValues');
        }
        else {
            //No Filters for the data
            $filterValues = 'NoFilter';
        }
        $formQuery = $this->configmodel->getNoFilterDataByFormName($databaseName, $formName,
                                                                  $formType);
        ///Added Later to allow generated form to order by the Old Columns///
        ///Can be improved so that data is not processed twice////
        foreach ($formQuery->result() as $formRow) {
                  $columnType = $formRow->ColumnType;
                  $columnNumber = $formRow->ColumnNumber;
                  $attributes = $formRow->Attributes;
                  if ($columnType == 'Old') {
                      $columnDetailA = $this->_processOld($attributes);
                      $columnName = $columnDetailA['columnName'];
                  }
                  if($orderBy == "")
                    $orderBy = $columnName;
                  else
                    $orderBy = $orderBy.",".$columnName;
        }
        /////////////////////////////////////////////
        if ($formQuery->num_rows() > 0) {
            $dataExtractQuery = $this->formmodel->getOldData($tableName, $filterValues, $orderBy);
            if ($dataExtractQuery->num_rows() > 0) {
                $rowNumber = 1;
                foreach ($dataExtractQuery->result() as $dataRow) {
                    foreach ($formQuery->result() as $formRow) {
                        $columnType = $formRow->ColumnType;
                        $columnNumber = $formRow->ColumnNumber;
                        $attributes = $formRow->Attributes;
                        if ($columnType == 'Old') {
                            $columnDetailA = $this->_processOld($attributes);
                            $columnName = $columnDetailA['columnName'];
                            $columnSize = $columnDetailA['columnSize'];
                            $columnValue = $dataRow->$columnName;
                            $createColumn = $this->_readOnlyAddColumn($columnValue, $columnName,
                                                                     $rowNumber, $columnSize
                                                                     );
                            $checkTabA[$columnNumber] = "n";
                        }
                        elseif ($columnType == 'text') {
                            $columnDetailA = $this->_textAttributes($attributes);
                            $columnDetailA['columnType'] = $columnType;
                            $columnName = $columnDetailA['columnName'];
                            $columnSize = $columnDetailA['columnSize'];
                            $createColumn = $this->_addColumnRow($columnDetailA, $rowNumber,
                                                                $columnValue);
                            $checkTabA[$columnNumber] = "yes";
                        }
                        elseif ($columnType == 'limit') {
                            $columnDetailA = $this->_limitAttributes($attributes);
                            $columnDetailA['columnType'] = $columnType;
                            $columnName = $columnDetailA['columnName'];
                            $columnSize = $columnDetailA['columnSize'];
                            $createColumn = $this->_addColumnRow($columnDetailA, $rowNumber,
                                                                $columnValue);
                            $checkTabA[$columnNumber] = "yes";
                        }
                        elseif  ($columnType == 'userdd') {
                            $columnDetailA = $this->_userddAttributes($attributes);
                            $columnDetailA['columnType'] = $columnType;
                            $columnName = $columnDetailA['columnName'];
                            //$columnSize = $columnDetailA['columnSize'];
                            $createColumn = $this->_addColumnRow($columnDetailA, $rowNumber,
                                                                $columnValue);
                            $checkTabA[$columnNumber] = "yes";
                        }
                        $headerListA[$columnNumber] = $columnDetailA['columnHeader'];
                        $columnNameA[$columnNumber] = $columnName;
                        $columnListA[$columnNumber] = $createColumn;
                    }
                    $rowNumber++;
                    $this->table->add_row($columnListA);
                }
                $this->table->set_heading($headerListA);
                $table2 = $this->table->generate();
            }
            else {
                //No data found
            }
        }
        else {
            //No Columns in the form.
        }

        //$this->table->set_heading($headerListA);
        //$this->table->add_row($columnListA);
        $data['table2'] = $table2;
        $row_count = '<input type="hidden" id="row_count" name="row_count" value="1" />';
        $hiddenValues = $row_count;
        /////////////////////////////////////////////////////////
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Entry Form Preview";
        $data['formHeading'] = "";
        $data['formOpen'] = "";
        $data['backLink'] = anchor('forms/addcolumnold/', 'Back', array('class' => 'back'));
        //CheckTab Javascript
        $data['checkTabJS'] = $this->_createCheckTab($columnNameA, $checkTabA);
        $data['insertRowJS'] = "";
        $data['submitButton'] = "";
        $data['hiddenValues'] = $hiddenValues;
        $this->load->view('treeforms/simpleform', $data);
        ///////////
    }


    function filter() {
        $filterArgs = $this->session->userdata('filterArgs');
        $columnHeader = $filterArgs['columnHeader'];
        $columnName = $filterArgs['columnName'];
        $tableName = $filterArgs['tableName'];
        $filterValues = $filterArgs['filterValues'];
        $data['title'] = "Configuration Form";
        $data['contentTitle'] = "Select ".$columnHeader;
        $data['formHeading'] = "";
        $data['formOpen'] = form_open("oldform/filtervalidate");
        $data['table'] = $this->_filterTable($columnHeader, $columnName, $tableName, $filterValues
                                            );
        $data['backLink'] = "";
        $this->load->view('forms/simpleform', $data);
    }


    function filtervalidate() {
        $filterArgs = $this->session->userdata('filterArgs');
        $columnHeader = $filterArgs['columnHeader'];
        $columnName = $filterArgs['columnName'];
        $tableName = $filterArgs['tableName'];
        $filterValues = $filterArgs['filterValues'];
        $this->_validateFilterTable($columnHeader);
        if ($this->form_validation->run() == FALSE) {
            $data['title'] = "Configuration Form";
            $data['contentTitle'] = "Select ".$columnHeader;
            $data['formHeading'] = "";
            $data['formOpen'] = form_open("oldform/filtervalidate");
            $data['table'] = $this->_filterTable($columnHeader, $columnName, $tableName, $filterValues
                                                );
            $data['backLink'] = "";
            $this->load->view('forms/simpleform', $data);
        }
        else {
            $filter = $this->input->post('filterDD');
            $filterValues[$columnName] = $filter;
            $this->session->set_userdata('filterValues', $filterValues);
            redirect('oldform/createform');
        }
    }


    function _filterTable($columnHeader, $columnName, $tableName, $filterValues) {
        $filterDD = set_value('filterDD');
        $filterListA = $this->formmodel->getFilterList($columnName, $tableName, $filterValues
                                                      );
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' =>
                              'submit', 'content' => 'Submit');
        $filterDD = form_dropdown('filterDD', $filterListA);
        $filterDDErr = form_error('filterDD');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array(), array('Select '.$columnHeader.' : ', $filterDD, $filterDDErr
                           ), array('', "<br />"), array('', $submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }


    function _validateFilterTable($columnHeader) {
        $this->form_validation->set_rules('filterDD', $columnHeader,
                                         'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }


    function _processOld($attributes) {
        $attArray = explode("\t", $attributes);
        $oldAttributes['columnHeader'] = $attArray[0];
        $oldAttributes['columnName'] = $attArray[1];
        $oldAttributes['columnSize'] = $attArray[2];
        return $oldAttributes;
    }


    function _textAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['defaultValue'] = $attributeA[3];
        $array ['columnSize'] = $attributeA[4];
        $array ['allowNull'] = $attributeA[5];
        return $array;
    }


    function _limitAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['dataType'] = $attributeA[2];
        $array ['upperLimit'] = $attributeA[3];
        $array ['lowerLimit'] = $attributeA[4];
        $array ['defaultValue'] = $attributeA[5];
        $array ['columnSize'] = $attributeA[6];
        $array ['allowNull'] = $attributeA[7];
        return $array;
    }

    function _userddAttributes($attributes) {
        $attributeA = explode("\t", $attributes);
        $array ['columnHeader'] = $attributeA[0];
        $array ['columnName'] = $attributeA[1];
        $array ['userData'] = $attributeA[2];
        return $array;
    }


    function _readOnlyAddColumn($value, $columnName, $rowNumber, $columnSize) {
        $columnName = $columnName."_".$rowNumber;
        $onKeyStroke = 'return checkTab(event,this);';
        $dataA = array('id' => $columnName, 'name' => $columnName, 'value' => $value,
                      'size' => $columnSize, 'readonly' => 'readonly', 'style' =>
                      'background:#CCCCCC; border:0; text-align: center;');
        $columnTbx = form_input($dataA);
        return $columnTbx;
    }


    function _addColumnRow($columnDetailA, $rowNumber) {
        if ($columnDetailA['columnType'] == 'text') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $columnSize = $columnDetailA['columnSize'];
            $defaultValue = $columnDetailA['defaultValue'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateNotEmpty(this)';
            }
            else {
                $onBlur = "";
            }
            $onKeyStroke = 'return checkTab(event,this);';
            $dataA = array('id' => $columnName, 'name' => $columnName, 'size' => $columnSize,
                          'value' => $defaultValue, 'onblur' => $onBlur, 'onkeypress' => $onKeyStroke
                          );
            $columnTbx = form_input($dataA);
            return $columnTbx;
        }
        elseif ($columnDetailA['columnType'] == 'limit') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $columnSize = $columnDetailA['columnSize'];
            $defaultValue = $columnDetailA['defaultValue'];
            $lowerLimit = $columnDetailA['lowerLimit'];
            $upperLimit = $columnDetailA['upperLimit'];
            if ($columnDetailA['allowNull'] == 'no') {
                $onBlur = 'validateLimitNotEmpty(this,'.$lowerLimit.','.$upperLimit.')';
            }
            else {
                $onBlur = 'validateLimit(this,'.$lowerLimit.','.$upperLimit.')';
            }
            $onKeyStroke = 'return checkTab(event,this);';
            $dataA = array('id' => $columnName, 'name' => $columnName, 'size' => $columnSize,
                          'value' => $defaultValue, 'onblur' => $onBlur, 'onkeypress' => $onKeyStroke
                          );
            $columnTbx = form_input($dataA).'<br />';
            return $columnTbx;
        }
        elseif ($columnDetailA['columnType'] == 'userdd') {
            $columnName = $columnDetailA['columnName']."_".$rowNumber;
            $userData = $columnDetailA['userData'];
            $userDataExplode = explode(';', $userData);
            foreach ($userDataExplode as $key => $value) {
                $userDataArray[$value] = trim($value);
            }
            $onKeyStroke = 'return checkTab(event,this);';
            $js = 'id = '.$columnName.' onkeypress = "'.$onKeyStroke.'"';
            $columnDD = form_dropdown($columnName, $userDataArray, '', $js).'<br />';
            return $columnDD;
        }
    }


    //////////////////CheckTab JS/////////////////////////////
    function _createCheckTab($columnNameA, $checkTabA) {
        $checkTabAsc = $this->_checkTabAsc($columnNameA, $checkTabA);
        $checkTabDesc = $this->_checkTabDesc($columnNameA, $checkTabA);
        $checkTabJS =
        '<script type="text/javascript">
                    function checkTab(e, obj) {
                   	var keynum;
                	var keychar;
                	var next;

                	if(window.event) // IE
                  	{
                  		keynum = e.keyCode;
                  	}
                	else if(e.which) // Netscape/Firefox/Opera
                  	{
                 		 keynum = e.which;
                  	}

                   if (keynum == 42) {
                        var id_arr = obj.id.split("_");'
                        .$checkTabAsc.
                        'return false;
                    } else if (keynum == 47) {
                        var id_arr = obj.id.split("_");'
                        .$checkTabDesc.
                        'return false;
                    } else if (keynum == 13) {
                        return false;
                    } else {
                		return true;
                	}
                }
                </script>';
        return $checkTabJS;
    }


    function _checkTabAsc($columnNameA, $checkTabA) {
        $checkTabAsc = "";
        $arrayCount = count($columnNameA);
        $a = "";
        $b = "";
        for ($i = 1; $i <= $arrayCount; $i++) {
            if ($checkTabA[$i] == 'yes') {
                $firstColumn = $columnNameA[$i];
                $a = $i;
                break;
            }
        }
        for ($i = 1; $i <= $arrayCount; $i++) {
            if ($checkTabA[$i] == 'yes') {
                $lastColumn = $columnNameA[$i];
                $b = $i;
            }
        }
        for ($i = 1; $i <= $arrayCount; $i++) {
            if ($checkTabA[$i] == 'yes') {
                $columnName1 = $columnNameA[$i];
                for ($j = $i + 1; $j <= $arrayCount; $j++) {
                    if ($checkTabA[$j] == 'yes') {
                        $columnName2 = $columnNameA[$j];
                        break;
                    }
                }
                //$columnName1 = $columnNameA[$i];
                //$columnName2 = $columnNameA[$i+1];
                if ($i == $a) {
                    $checkTabAsc = $checkTabAsc.'if (id_arr[0] == "'.$columnName1.
                                                    '")
                                  {
                                  document.getElementById("'
                                                    .$columnName2.
                                                    '_"+id_arr[1] ).focus();
                                  }';
                }
                elseif ($i == $b) {
                    $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.
                                                         '")
                                  {
                                   var nextRow = parseInt(id_arr[1]) + 1;
                                   document.getElementById("'
                                                         .$firstColumn.
                                                         '_"+nextRow).focus();
                                  }';
                }
                else {
                    $checkTabAsc = $checkTabAsc.'else if (id_arr[0] == "'.$columnName1.
                                                         '")
                                  {
                                   document.getElementById("'
                                                         .$columnName2.
                                                         '_"+id_arr[1] ).focus();
                                  }';
                }
            }
        }
        return $checkTabAsc;
    }


    function _checkTabDesc($columnNameA, $checkTabA) {
        $checkTabDesc = "";
        $arrayCount = count($columnNameA);
        $a = "";
        $b = "";
        for ($i = 1; $i <= $arrayCount; $i++) {
            if ($checkTabA[$i] == 'yes') {
                $firstColumn = $columnNameA[$i];
                $a = $i;
                break;
            }
        }
        for ($i = 1; $i <= $arrayCount; $i++) {
            if ($checkTabA[$i] == 'yes') {
                $lastColumn = $columnNameA[$i];
                $b = $i;
            }
        }
        for ($i = $arrayCount; $i >= 1; $i--) {
            if ($checkTabA[$i] == 'yes') {
                $columnName1 = $columnNameA[$i];
                for ($j = $i - 1; $j >= 1; $j--) {
                    if ($checkTabA[$j] == 'yes') {
                        $columnName2 = $columnNameA[$j];
                        break;
                    }
                }
                //$columnName1 = $columnNameA[$i];
                //$columnName2 = $columnNameA[$i-1];
                if ($i == $b) {
                    $checkTabDesc = $checkTabDesc.'if (id_arr[0] == "'.$columnName1.
                                                      '")
                                {
                                 document.getElementById("'
                                                      .$columnName2.
                                                      '_"+id_arr[1] ).focus();
                                }';
                }
                elseif ($i == $a) {
                    $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$firstColumn.
                                                           '")
                                {
                                 var prevRow = parseInt(id_arr[1]) - 1;
                                 document.getElementById("'
                                                           .$lastColumn.
                                                           '_"+prevRow ).focus();
                                }';
                }
                else {
                    $checkTabDesc = $checkTabDesc.'else if (id_arr[0] == "'.$columnName1.
                                                           '")
                                {
                                 document.getElementById("'
                                                           .$columnName2.
                                                           '_"+id_arr[1] ).focus();
                                }';
                }
            }
        }
        return $checkTabDesc;
    }


    /////////////////////////////////////////////////////////////////////
    //////Helper Functions//////
    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected'
                                               );
            return FALSE;
        }
        else {
            return True;
        }
    }


}
