<?php

class Selectmergefile extends Controller {

    function Selectmergefile() {
        parent :: Controller();
        if ($this->session->userdata('loggedin') !== '1') {
            redirect('main', 'location');
        }
        global $databaseName;
        $databaseName = $this->session->userdata('databaseName');
    }

    function selectfile() {
        $formName = $this->session->userdata('formName');
        $data['formOpen'] = form_open("selectmergefile/selectfilevalidate");
        $fileNameArray = $this->_getFileNameArray($formName);
        $data['formTable'] = $this->_selectFileTable($fileNameArray);
        $data['title'] = 'CTFS Generic Data Entry';
        $data['contentTitle'] =
        'Select Merge File - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
        '</span></span>';
        $data['backLink'] = anchor('/dataentry/mainmenu', 'Back', array('title' => 'Back to Data Entry', 'class' =>
                                  'back'));
        $this->load->view('user/dataentry/simpleform', $data);
    }

    function selectfilevalidate() {
        $this->_validateselectfile();
        $fileNameArray = $this->input->post('fileNameArray');
        //$formType = $this->input->post('formType');
        $formName = $this->session->userdata('formName');
        if ($this->form_validation->run() == FALSE) {
            $data['formTable'] = $this->_selectFileTable($fileNameArray);
            $data['formOpen'] = form_open("selectmergefile/selectfilevalidate");
            $data['title'] = 'CTFS Generic Data Entry';
            $data['contentTitle'] =
            'Select Merge File - <span style="font-size:.7em;"> Form Name: <span style="color:#8C0209;">'.$formName.
            '</span></span>';
            $data['backLink'] = anchor('/dataentry/mainmenu', 'Back', array('title' => 'Back to Data Entry', 'class' =>
                                      'back'));
            $this->load->view('user/dataentry/simpleform', $data);
        }
        else {
            $fileName = $this->input->post('fileName');
            $this->session->set_userdata('mergefilename', $fileName);
            redirect('gdeplantform/createform/merge');
        }
    }

    function _getFileNameArray($formName) {
        $dir = "./files/datafiles/gdedatafile/";
        //form with drop down - listing files in the selected form type folder
        if (is_dir($dir)) {
            if ($dh = opendir($dir)) {
                $fileNameArray = array();
                //$fileNameArray['default'] = 'No Files In Folder';
                while (($file = readdir($dh)) !== false) {
                    if ($file !== "." && $file !== "..") {
                        $fileSplit = explode(".", $file);
                        $file = $fileSplit[0];
                        // Remove .txt from the end - need to remove for dropdown
                        $fileSplit1 = explode("_", $file);
                        if ($fileSplit1[0] == $formName) {
                            $fileNameArray[$file] = $file;
                        }
                        $fileNameArray['default'] = 'Select';
                    }
                }
                natcasesort($fileNameArray);
                $defaultArray = array('default' => 'Select');
                $fileNameArray = array_merge($defaultArray, $fileNameArray);
                closedir($dh);
            }
        }
        else {
            $fileNameArray = array('default' => 'Unable Access Dir');
        }
        return $fileNameArray;
    }

    function _selectFileTable($fileNameArray) {
        $fileName = set_value('fileName');
        $fileNameDD = form_dropdown('fileName', $fileNameArray);
        $fileNameHd = form_hidden('fileNameArray', $fileNameArray);
        //$formTypeHd = form_hidden('formType',$formType);
        $fileNameErr = form_error('fileName');
        $submitButtonA = array('name' => 'submitButton', 'id' => 'button', 'type' => 'submit', 'content' => 'Submit');
        $submitButton = form_button($submitButtonA);
        $formTableA = array(array(), array('Select File : ', $fileNameDD, $fileNameErr), array('', $fileNameHd), array(
                           '', $submitButton));
        $this->table->set_empty("");
        $formTable = $this->table->generate($formTableA);
        return $formTable;
    }

    function _validateselectfile() {
        $this->form_validation->set_rules('fileName', 'File', 'callback_dropdown_check');
        $this->form_validation->set_error_delimiters('<p class="errorblock">', '</p>');
    }

    function dropdown_check($str) {
        if ($str == 'default') {
            $this->form_validation->set_message('dropdown_check', '%s need to be Selected');
            return FALSE;
        }
        else {
            return True;
        }
    }

}
