<?php

class Doublescreeningmodel extends Model {

    function Doublescreeningmodel() {
        parent :: Model();
        $database = $this->session->userdata('databaseName');
        $this->dscreeningdb = $this->load->database($database, TRUE);
    }

    function tableNameList($like) {
        $query = "SHOW TABLES LIKE '".$like."'";
        $runQ = $this->dscreeningdb->query($query);
        $list = array();
        $list['default'] = 'Select';
        if ($runQ->num_rows() > 0) {
            foreach ($runQ->result_array() as $row) {
                $tableName = current($row);
                $list[$tableName] = $tableName;
            }
        }
        return $list;
    }

    function executeQuery($query) {
        $result = $this->dscreeningdb->query($query);
        return $result;
    }

    function getColumnNames($tableName) {
        $fields = $this->dscreeningdb->list_fields($tableName);
        return $fields;
    }

    function fetchAllRecords($tableName) {
        $this->dscreeningdb->select('*');
        $this->dscreeningdb->from($tableName);
        $this->dscreeningdb->order_by($tableName.'ID');
        $query = $this->dscreeningdb->get();
        return $query;
    }

    function fetchCompareRecord($tableName, $whereArray) {
        $this->dscreeningdb->select('*');
        $this->dscreeningdb->where($whereArray);
        $query = $this->dscreeningdb->get($tableName);
        return $query;
    }

    function insertRowIntoTable($tableName, $insertArray) {
        $query = $this->dscreeningdb->insert($tableName, $insertArray);
        return $query;
    }

    function deleteTempRecord($tableName, $tempID) {
        $this->dscreeningdb->where($tableName.'ID', $tempID);
        $this->dscreeningdb->delete($tableName);
    }

    function fetchRecordByTempID($tableName, $tempID) {
        $this->dscreeningdb->select('*');
        $this->dscreeningdb->where($tableName.'ID', $tempID);
        $query = $this->dscreeningdb->get($tableName);
        return $query;
    }

    function getNextTempID($tableName) {
        $this->dscreeningdb->select_max($tableName.'ID');
        $query = $this->dscreeningdb->get($tableName);
        $row = $query->row_array();
        $nextTempID = $row[$tableName.'ID'] + 1;
        return $nextTempID;
    }

    function updataTempID($tableName, $tempID, $newTempID) {
        $updateA = array($tableName.'ID' => $newTempID);
        $this->dscreeningdb->where($tableName.'ID', $tempID);
        $this->dscreeningdb->update($tableName, $updateA);
    }

    function startTransaction() {
        $this->dscreeningdb->trans_start();
    }

    function completeTransaction() {
        $this->dscreeningdb->trans_complete();
    }

}
