<?php

class Fileuploadmodel extends Model {

    function Fileuploadmodel() {
        parent :: Model();
        $database = $this->session->userdata('databaseName');
        $this->uploaddb = $this->load->database($database, TRUE);
    }

    function getTableList() {
        $query = "SHOW TABLES";
        $runQ = $this->uploaddb->query($query);
        $list = array();
        $list['default'] = 'Select';
        if ($runQ->num_rows() > 0) {
            foreach ($runQ->result_array() as $row) {
                $tableName = current($row);
                $list[$tableName] = $tableName;
            }
        }
        return $list;
    }

    function getTableColumns($tableName) {
        $runQ = $this->uploaddb->query('SHOW COLUMNS FROM '.$tableName);
        $list = array();
        foreach ($runQ->result_array() as $row) {
            $fieldName = $row['Field'];
            $list[$fieldName] = $fieldName;
        }
        return $list;
    }

    function uploadToTable($tableName, $data) {
        $this->uploaddb->trans_start();
        foreach($data as $row) {
            $this->uploaddb->insert($tableName, $row);
        }
        $this->uploaddb->trans_complete();
        if ($this->uploaddb->trans_status() === TRUE) {
            $reportBack = 'Done';
        }
        else {
            $reportBack = 'Fail';
        }
        return $reportBack;
    }

}
