<?php

class Formmodel extends Model {

    function Formmodel() {
        parent :: Model();
        $database = $this->session->userdata('databaseName');
        $this->formdb = $this->load->database($database, TRUE);
    }

    function getTableList($like) {
        $query = "SHOW TABLES LIKE '".$like."'";
        $runQ = $this->formdb->query($query);
        $list = array();
        $list['default'] = 'Select';
        if ($runQ->num_rows() > 0) {
            foreach ($runQ->result_array() as $row) {
                $tableName = current($row);
                $list[$tableName] = $tableName;
            }
        }
        return $list;
    }

    function getTableColumns($tableName) {
        $runQ = $this->formdb->query('SHOW COLUMNS FROM '.$tableName);
        $list = array();
        foreach ($runQ->result_array() as $row) {
            $fieldName = $row['Field'];
            $list[$fieldName] = $fieldName;
        }
        return $list;
    }

    function getFilterList($columnName, $tableName, $filterValues) {
        $this->formdb->distinct($columnName);
        $this->formdb->from($tableName);
        if (count($filterValues) > 0) {
            foreach ($filterValues as $key => $value) {
                $this->formdb->where($key, $value);
            }
        }
        $this->formdb->order_by($columnName);
        $query = $this->formdb->get();
        $list = array();
        $list['default'] = 'Select';
        if ($query->num_rows() > 0) {
            foreach ($query->result_array() as $row) {
                $listValues = $row[$columnName];
                $list[$listValues] = $listValues;
            }
        }
        return $list;
    }

    function getOldData($tableName, $filterValues, $orderBy) {
        $this->formdb->select('*');
        $this->formdb->from($tableName);
        if ($filterValues !== 'NoFilter') {
            foreach ($filterValues as $key => $value) {
                $this->formdb->where($key, $value);
            }
        }
        if ($orderBy !== "") {
            $this->formdb->order_by($orderBy);
        }
        $query = $this->formdb->get();
        return $query;
    }

}
